use ::libc;
extern "C" {
    #[no_mangle]
    fn usleep(__useconds: __useconds_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_attr_destroy(__attr: *mut pthread_attr_t) -> libc::c_int;
    #[no_mangle]
    fn strstr(_: *const libc::c_char, _: *const libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn pthread_create(__newthread: *mut pthread_t,
                      __attr: *const pthread_attr_t,
                      __start_routine:
                          Option<unsafe extern "C" fn(_: *mut libc::c_void)
                                     -> *mut libc::c_void>,
                      __arg: *mut libc::c_void) -> libc::c_int;
    #[no_mangle]
    fn pthread_join(__th: pthread_t, __thread_return: *mut *mut libc::c_void)
     -> libc::c_int;
    #[no_mangle]
    fn pthread_attr_init(__attr: *mut pthread_attr_t) -> libc::c_int;
    #[no_mangle]
    fn register_faad() -> *mut codec;
    #[no_mangle]
    fn register_vorbis() -> *mut codec;
    #[no_mangle]
    fn register_flac() -> *mut codec;
    #[no_mangle]
    fn register_pcm() -> *mut codec;
    #[no_mangle]
    fn register_mad() -> *mut codec;
    #[no_mangle]
    fn register_mpg() -> *mut codec;
    #[no_mangle]
    fn _checkfade(_: bool);
    #[no_mangle]
    fn wake_controller();
    #[no_mangle]
    fn _buf_space(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_used(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn pthread_attr_setstacksize(__attr: *mut pthread_attr_t,
                                 __stacksize: size_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_destroy(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_init(__mutex: *mut pthread_mutex_t,
                          __mutexattr: *const pthread_mutexattr_t)
     -> libc::c_int;
    #[no_mangle]
    static mut streambuf: *mut buffer;
    #[no_mangle]
    static mut outputbuf: *mut buffer;
    #[no_mangle]
    static mut stream: streamstate;
    #[no_mangle]
    static mut output: outputstate;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type __useconds_t = libc::c_uint;
pub type int32_t = __int32_t;
pub type u_int8_t = __uint8_t;
pub type u_int32_t = __uint32_t;
pub type u_int64_t = __uint64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
pub type pthread_t = libc::c_ulong;
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutexattr_t {
    pub __size: [libc::c_char; 4],
    pub __align: libc::c_int,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_attr_t {
    pub __size: [libc::c_char; 56],
    pub __align: libc::c_long,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type u8_t = u_int8_t;
pub type u32_t = u_int32_t;
pub type u64_t = u_int64_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type stream_state = libc::c_uint;
pub const RECV_HEADERS: stream_state = 7;
pub const SEND_HEADERS: stream_state = 6;
pub const STREAMING_HTTP: stream_state = 5;
pub const STREAMING_FILE: stream_state = 4;
pub const STREAMING_BUFFERING: stream_state = 3;
pub const STREAMING_WAIT: stream_state = 2;
pub const DISCONNECT: stream_state = 1;
pub const STOPPED: stream_state = 0;
pub type disconnect_code = libc::c_uint;
pub const TIMEOUT: disconnect_code = 4;
pub const UNREACHABLE: disconnect_code = 3;
pub const REMOTE_DISCONNECT: disconnect_code = 2;
pub const LOCAL_DISCONNECT: disconnect_code = 1;
pub const DISCONNECT_OK: disconnect_code = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct streamstate {
    pub state: stream_state,
    pub disconnect: disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: u32_t,
    pub meta_next: u32_t,
    pub meta_left: u32_t,
    pub meta_send: bool,
}
pub type decode_state = libc::c_uint;
pub const DECODE_ERROR: decode_state = 4;
pub const DECODE_COMPLETE: decode_state = 3;
pub const DECODE_RUNNING: decode_state = 2;
pub const DECODE_READY: decode_state = 1;
pub const DECODE_STOPPED: decode_state = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct decodestate {
    pub state: decode_state,
    pub new_stream: bool,
    pub mutex: pthread_mutex_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct codec {
    pub id: libc::c_char,
    pub types: *mut libc::c_char,
    pub min_read_bytes: libc::c_uint,
    pub min_space: libc::c_uint,
    pub open: Option<unsafe extern "C" fn(_: u8_t, _: u8_t, _: u8_t, _: u8_t)
                         -> ()>,
    pub close: Option<unsafe extern "C" fn() -> ()>,
    pub decode: Option<unsafe extern "C" fn() -> decode_state>,
}
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_RUNNING: output_state = 2;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// decode thread
#[no_mangle]
pub static mut loglevel: log_level = lERROR;
#[no_mangle]
pub static mut decode: decodestate =
    decodestate{state: DECODE_STOPPED,
                new_stream: false,
                mutex:
                    pthread_mutex_t{__data:
                                        __pthread_mutex_s{__lock: 0,
                                                          __count: 0,
                                                          __owner: 0,
                                                          __nusers: 0,
                                                          __kind: 0,
                                                          __spins: 0,
                                                          __elision: 0,
                                                          __list:
                                                              __pthread_list_t{__prev:
                                                                                   0
                                                                                       as
                                                                                       *const __pthread_internal_list
                                                                                       as
                                                                                       *mut __pthread_internal_list,
                                                                               __next:
                                                                                   0
                                                                                       as
                                                                                       *const __pthread_internal_list
                                                                                       as
                                                                                       *mut __pthread_internal_list,},},},};
#[no_mangle]
pub static mut codecs: [*mut codec; 10] =
    [0 as *const codec as *mut codec; 10];
#[no_mangle]
pub static mut codec: *mut codec = 0 as *const codec as *mut codec;
static mut flac_container: u8_t = '?' as i32 as u8_t;
static mut running: bool = 1 as libc::c_int != 0;
unsafe extern "C" fn decode_thread() -> *mut libc::c_void {
    while running {
        let mut bytes: size_t = 0;
        let mut space: size_t = 0;
        let mut min_space: size_t = 0;
        let mut toend: bool = false;
        let mut ran: bool = 0 as libc::c_int != 0;
        pthread_mutex_lock(&mut (*streambuf).mutex);
        bytes = _buf_used(streambuf) as size_t;
        toend =
            stream.state as libc::c_uint <=
                DISCONNECT as libc::c_int as libc::c_uint;
        pthread_mutex_unlock(&mut (*streambuf).mutex);
        pthread_mutex_lock(&mut (*outputbuf).mutex);
        space = _buf_space(outputbuf) as size_t;
        pthread_mutex_unlock(&mut (*outputbuf).mutex);
        pthread_mutex_lock(&mut decode.mutex);
        if decode.state as libc::c_uint ==
               DECODE_RUNNING as libc::c_int as libc::c_uint &&
               !codec.is_null() {
            if loglevel as libc::c_uint >=
                   lSDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d streambuf bytes: %u outputbuf space: %u\n\x00"
                             as *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"decode_thread\x00")).as_ptr(),
                         76 as libc::c_int, bytes, space);
            }
            min_space = (*codec).min_space as size_t;
            if space > min_space &&
                   (bytes > (*codec).min_read_bytes as libc::c_ulong ||
                        toend as libc::c_int != 0) {
                decode.state =
                    (*codec).decode.expect("non-null function pointer")();
                if decode.state as libc::c_uint !=
                       DECODE_RUNNING as libc::c_int as libc::c_uint {
                    if loglevel as libc::c_uint >=
                           lINFO as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d decode %s\n\x00" as *const u8 as
                                     *const libc::c_char, logtime(),
                                 (*::std::mem::transmute::<&[u8; 14],
                                                           &[libc::c_char; 14]>(b"decode_thread\x00")).as_ptr(),
                                 101 as libc::c_int,
                                 if decode.state as libc::c_uint ==
                                        DECODE_COMPLETE as libc::c_int as
                                            libc::c_uint {
                                     b"complete\x00" as *const u8 as
                                         *const libc::c_char
                                 } else {
                                     b"error\x00" as *const u8 as
                                         *const libc::c_char
                                 });
                    }
                    pthread_mutex_lock(&mut (*outputbuf).mutex);
                    if output.fade_mode as u64 != 0 {
                        _checkfade(0 as libc::c_int != 0);
                    }
                    pthread_mutex_unlock(&mut (*outputbuf).mutex);
                    wake_controller();
                }
                ran = 1 as libc::c_int != 0
            }
        }
        pthread_mutex_unlock(&mut decode.mutex);
        if !ran { usleep(100000 as libc::c_int as __useconds_t); }
    }
    return 0 as *mut libc::c_void;
}
unsafe extern "C" fn sort_codecs(mut pry: libc::c_int, mut ptr: *mut codec) {
    static mut priority: [libc::c_int; 10] = [0; 10];
    let mut i: libc::c_int = 0;
    let mut tpry: libc::c_int = 0;
    let mut tptr: *mut codec = 0 as *mut codec;
    i = 0 as libc::c_int;
    while i < 10 as libc::c_int {
        if codecs[i as usize].is_null() {
            codecs[i as usize] = ptr;
            priority[i as usize] = pry;
            return
        }
        if pry < priority[i as usize] {
            tptr = codecs[i as usize];
            codecs[i as usize] = ptr;
            ptr = tptr;
            tpry = priority[i as usize];
            priority[i as usize] = pry;
            pry = tpry
        }
        i += 1
    };
}
static mut thread: pthread_t = 0;
#[no_mangle]
pub unsafe extern "C" fn decode_init(mut level: log_level,
                                     mut include_codecs: *const libc::c_char,
                                     mut exclude_codecs:
                                         *const libc::c_char) {
    let mut i: libc::c_int = 0;
    let mut order_codecs: *mut libc::c_char = 0 as *mut libc::c_char;
    loglevel = level;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d init decode\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"decode_init\x00")).as_ptr(),
                 154 as libc::c_int);
    }
    // register codecs
	// dsf,dff,alc,wma,wmap,wmal,aac,spt,ogg,ogf,flc,aif,pcm,mp3
    i = 0 as libc::c_int;
    if strstr(exclude_codecs,
              b"aac\x00" as *const u8 as *const libc::c_char).is_null() &&
           (include_codecs.is_null() ||
                {
                    order_codecs =
                        strstr(include_codecs,
                               b"aac\x00" as *const u8 as
                                   *const libc::c_char);
                    !order_codecs.is_null()
                }) {
        sort_codecs(if !include_codecs.is_null() {
                        order_codecs.wrapping_offset_from(include_codecs) as
                            libc::c_long
                    } else { i as libc::c_long } as libc::c_int,
                    register_faad());
    }
    if strstr(exclude_codecs,
              b"ogg\x00" as *const u8 as *const libc::c_char).is_null() &&
           (include_codecs.is_null() ||
                {
                    order_codecs =
                        strstr(include_codecs,
                               b"ogg\x00" as *const u8 as
                                   *const libc::c_char);
                    !order_codecs.is_null()
                }) {
        sort_codecs(if !include_codecs.is_null() {
                        order_codecs.wrapping_offset_from(include_codecs) as
                            libc::c_long
                    } else { i as libc::c_long } as libc::c_int,
                    register_vorbis());
    }
    if strstr(exclude_codecs,
              b"flac\x00" as *const u8 as *const libc::c_char).is_null() &&
           (include_codecs.is_null() ||
                {
                    order_codecs =
                        strstr(include_codecs,
                               b"flac\x00" as *const u8 as
                                   *const libc::c_char);
                    !order_codecs.is_null()
                }) {
        sort_codecs(if !include_codecs.is_null() {
                        order_codecs.wrapping_offset_from(include_codecs) as
                            libc::c_long
                    } else { i as libc::c_long } as libc::c_int,
                    register_flac());
    }
    if strstr(exclude_codecs,
              b"pcm\x00" as *const u8 as *const libc::c_char).is_null() &&
           (include_codecs.is_null() ||
                {
                    order_codecs =
                        strstr(include_codecs,
                               b"pcm\x00" as *const u8 as
                                   *const libc::c_char);
                    !order_codecs.is_null()
                }) {
        sort_codecs(if !include_codecs.is_null() {
                        order_codecs.wrapping_offset_from(include_codecs) as
                            libc::c_long
                    } else { i as libc::c_long } as libc::c_int,
                    register_pcm());
    }
    // try mad then mpg for mp3 unless command line option passed
    if !(!strstr(exclude_codecs,
                 b"mp3\x00" as *const u8 as *const libc::c_char).is_null() ||
             !strstr(exclude_codecs,
                     b"mad\x00" as *const u8 as
                         *const libc::c_char).is_null()) &&
           (include_codecs.is_null() ||
                {
                    order_codecs =
                        strstr(include_codecs,
                               b"mp3\x00" as *const u8 as
                                   *const libc::c_char);
                    !order_codecs.is_null()
                } ||
                {
                    order_codecs =
                        strstr(include_codecs,
                               b"mad\x00" as *const u8 as
                                   *const libc::c_char);
                    !order_codecs.is_null()
                }) {
        sort_codecs(if !include_codecs.is_null() {
                        order_codecs.wrapping_offset_from(include_codecs) as
                            libc::c_long
                    } else { i as libc::c_long } as libc::c_int,
                    register_mad());
    } else if !(!strstr(exclude_codecs,
                        b"mp3\x00" as *const u8 as
                            *const libc::c_char).is_null() ||
                    !strstr(exclude_codecs,
                            b"mpg\x00" as *const u8 as
                                *const libc::c_char).is_null()) &&
                  (include_codecs.is_null() ||
                       {
                           order_codecs =
                               strstr(include_codecs,
                                      b"mp3\x00" as *const u8 as
                                          *const libc::c_char);
                           !order_codecs.is_null()
                       } ||
                       {
                           order_codecs =
                               strstr(include_codecs,
                                      b"mpg\x00" as *const u8 as
                                          *const libc::c_char);
                           !order_codecs.is_null()
                       }) {
        sort_codecs(if !include_codecs.is_null() {
                        order_codecs.wrapping_offset_from(include_codecs) as
                            libc::c_long
                    } else { i as libc::c_long } as libc::c_int,
                    register_mpg());
    }
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d include codecs: %s exclude codecs: %s\n\x00" as
                     *const u8 as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"decode_init\x00")).as_ptr(),
                 195 as libc::c_int,
                 if !include_codecs.is_null() {
                     include_codecs
                 } else { b"\x00" as *const u8 as *const libc::c_char },
                 exclude_codecs);
    }
    pthread_mutex_init(&mut decode.mutex, 0 as *const pthread_mutexattr_t);
    let mut attr: pthread_attr_t = pthread_attr_t{__size: [0; 56],};
    pthread_attr_init(&mut attr);
    pthread_attr_setstacksize(&mut attr,
                              (16384 as libc::c_int +
                                   128 as libc::c_int * 1024 as libc::c_int)
                                  as size_t);
    pthread_create(&mut thread, &mut attr,
                   ::std::mem::transmute::<Option<unsafe extern "C" fn()
                                                      -> *mut libc::c_void>,
                                           Option<unsafe extern "C" fn(_:
                                                                           *mut libc::c_void)
                                                      ->
                                                          *mut libc::c_void>>(Some(::std::mem::transmute::<unsafe extern "C" fn()
                                                                                                               ->
                                                                                                                   *mut libc::c_void,
                                                                                                           unsafe extern "C" fn()
                                                                                                               ->
                                                                                                                   *mut libc::c_void>(decode_thread))),
                   0 as *mut libc::c_void);
    pthread_attr_destroy(&mut attr);
    decode.new_stream = 1 as libc::c_int != 0;
    decode.state = DECODE_STOPPED;
}
#[no_mangle]
pub unsafe extern "C" fn decode_close() {
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d close decode\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"decode_close\x00")).as_ptr(),
                 222 as libc::c_int);
    }
    pthread_mutex_lock(&mut decode.mutex);
    if !codec.is_null() {
        (*codec).close.expect("non-null function pointer")();
        codec = 0 as *mut codec
    }
    running = 0 as libc::c_int != 0;
    pthread_mutex_unlock(&mut decode.mutex);
    pthread_join(thread, 0 as *mut *mut libc::c_void);
    pthread_mutex_destroy(&mut decode.mutex);
}
#[no_mangle]
pub unsafe extern "C" fn decode_flush() {
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d decode flush\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"decode_flush\x00")).as_ptr(),
                 237 as libc::c_int);
    }
    pthread_mutex_lock(&mut decode.mutex);
    decode.state = DECODE_STOPPED;
    pthread_mutex_unlock(&mut decode.mutex);
}
#[no_mangle]
pub unsafe extern "C" fn decode_newstream(mut sample_rate: libc::c_uint,
                                          mut supported_rates:
                                              *mut libc::c_uint)
 -> libc::c_uint {
    // called with O locked to get sample rate for potentially processed output stream
	// release O mutex during process_newstream as it can take some time
    return sample_rate;
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
#[no_mangle]
pub unsafe extern "C" fn codec_open(mut format: u8_t, mut sample_size: u8_t,
                                    mut sample_rate: u8_t, mut channels: u8_t,
                                    mut endianness: u8_t) {
    let mut i: libc::c_int = 0;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d codec open: \'%c\'\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 11],
                                           &[libc::c_char; 11]>(b"codec_open\x00")).as_ptr(),
                 265 as libc::c_int, format as libc::c_int);
    }
    pthread_mutex_lock(&mut decode.mutex);
    decode.new_stream = 1 as libc::c_int != 0;
    decode.state = DECODE_STOPPED;
    // potentially changed within codec when processing enabled
    // find the required codec
    i = 0 as libc::c_int;
    while i < 10 as libc::c_int {
        if !codecs[i as usize].is_null() &&
               (*codecs[i as usize]).id as libc::c_int ==
                   format as libc::c_int {
            // close codec if format or flac container changed
            if !codec.is_null() &&
                   (codec != codecs[i as usize] ||
                        (*codecs[i as usize]).id as libc::c_int == 'f' as i32
                            &&
                            flac_container as libc::c_int !=
                                sample_size as libc::c_int) {
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d closing codec: \'%c\'\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 11],
                                                       &[libc::c_char; 11]>(b"codec_open\x00")).as_ptr(),
                             283 as libc::c_int, (*codec).id as libc::c_int);
                }
                (*codec).close.expect("non-null function pointer")();
            }
            codec = codecs[i as usize];
            if (*codec).id as libc::c_int == 'f' as i32 {
                flac_container = sample_size
            }
            (*codec).open.expect("non-null function pointer")(sample_size,
                                                              sample_rate,
                                                              channels,
                                                              endianness);
            decode.state = DECODE_READY;
            pthread_mutex_unlock(&mut decode.mutex);
            return
        }
        i += 1
    }
    pthread_mutex_unlock(&mut decode.mutex);
    logprint(b"%s %s:%d codec not found\n\x00" as *const u8 as
                 *const libc::c_char, logtime(),
             (*::std::mem::transmute::<&[u8; 11],
                                       &[libc::c_char; 11]>(b"codec_open\x00")).as_ptr(),
             303 as libc::c_int);
}
