use ::libc;
extern "C" {
    #[no_mangle]
    fn sscanf(_: *const libc::c_char, _: *const libc::c_char, _: ...)
     -> libc::c_int;
    #[no_mangle]
    fn malloc(_: libc::c_ulong) -> *mut libc::c_void;
    #[no_mangle]
    fn free(__ptr: *mut libc::c_void);
    #[no_mangle]
    fn memcpy(_: *mut libc::c_void, _: *const libc::c_void, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memcmp(_: *const libc::c_void, _: *const libc::c_void,
              _: libc::c_ulong) -> libc::c_int;
    #[no_mangle]
    fn strcmp(_: *const libc::c_char, _: *const libc::c_char) -> libc::c_int;
    #[no_mangle]
    fn dlopen(__file: *const libc::c_char, __mode: libc::c_int)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlsym(__handle: *mut libc::c_void, __name: *const libc::c_char)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlerror() -> *mut libc::c_char;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn unpackN(src: *mut u32_t) -> u32_t;
    #[no_mangle]
    fn _buf_used(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_read(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_write(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_inc_readp(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn _buf_inc_writep(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn decode_newstream(sample_rate: libc::c_uint,
                        supported_rates: *mut libc::c_uint) -> libc::c_uint;
    #[no_mangle]
    fn _checkfade(_: bool);
    #[no_mangle]
    static mut loglevel: log_level;
    #[no_mangle]
    static mut streambuf: *mut buffer;
    #[no_mangle]
    static mut outputbuf: *mut buffer;
    #[no_mangle]
    static mut stream: streamstate;
    #[no_mangle]
    static mut output: outputstate;
    #[no_mangle]
    static mut decode: decodestate;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type int32_t = __int32_t;
pub type u_int8_t = __uint8_t;
pub type u_int32_t = __uint32_t;
pub type u_int64_t = __uint64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type u8_t = u_int8_t;
pub type u32_t = u_int32_t;
pub type u64_t = u_int64_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type stream_state = libc::c_uint;
pub const RECV_HEADERS: stream_state = 7;
pub const SEND_HEADERS: stream_state = 6;
pub const STREAMING_HTTP: stream_state = 5;
pub const STREAMING_FILE: stream_state = 4;
pub const STREAMING_BUFFERING: stream_state = 3;
pub const STREAMING_WAIT: stream_state = 2;
pub const DISCONNECT: stream_state = 1;
pub const STOPPED: stream_state = 0;
pub type disconnect_code = libc::c_uint;
pub const TIMEOUT: disconnect_code = 4;
pub const UNREACHABLE: disconnect_code = 3;
pub const REMOTE_DISCONNECT: disconnect_code = 2;
pub const LOCAL_DISCONNECT: disconnect_code = 1;
pub const DISCONNECT_OK: disconnect_code = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct streamstate {
    pub state: stream_state,
    pub disconnect: disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: u32_t,
    pub meta_next: u32_t,
    pub meta_left: u32_t,
    pub meta_send: bool,
}
pub type decode_state = libc::c_uint;
pub const DECODE_ERROR: decode_state = 4;
pub const DECODE_COMPLETE: decode_state = 3;
pub const DECODE_RUNNING: decode_state = 2;
pub const DECODE_READY: decode_state = 1;
pub const DECODE_STOPPED: decode_state = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct decodestate {
    pub state: decode_state,
    pub new_stream: bool,
    pub mutex: pthread_mutex_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct codec {
    pub id: libc::c_char,
    pub types: *mut libc::c_char,
    pub min_read_bytes: libc::c_uint,
    pub min_space: libc::c_uint,
    pub open: Option<unsafe extern "C" fn(_: u8_t, _: u8_t, _: u8_t, _: u8_t)
                         -> ()>,
    pub close: Option<unsafe extern "C" fn() -> ()>,
    pub decode: Option<unsafe extern "C" fn() -> decode_state>,
}
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_RUNNING: output_state = 2;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct NeAACDecFrameInfo {
    pub bytesconsumed: libc::c_ulong,
    pub samples: libc::c_ulong,
    pub channels: libc::c_uchar,
    pub error: libc::c_uchar,
    pub samplerate: libc::c_ulong,
    pub sbr: libc::c_uchar,
    pub object_type: libc::c_uchar,
    pub header_type: libc::c_uchar,
    pub num_front_channels: libc::c_uchar,
    pub num_side_channels: libc::c_uchar,
    pub num_back_channels: libc::c_uchar,
    pub num_lfe_channels: libc::c_uchar,
    pub channel_position: [libc::c_uchar; 64],
    pub ps: libc::c_uchar,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct faad {
    pub hAac: NeAACDecHandle,
    pub type_0: u8_t,
    pub consume: u32_t,
    pub pos: u32_t,
    pub sample: u32_t,
    pub nextchunk: u32_t,
    pub stsc: *mut libc::c_void,
    pub skip: u32_t,
    pub samples: u64_t,
    pub sttssamples: u64_t,
    pub empty: bool,
    pub chunkinfo: *mut chunk_table,
    pub NeAACDecGetCurrentConfiguration: Option<unsafe extern "C" fn(_:
                                                                         NeAACDecHandle)
                                                    ->
                                                        NeAACDecConfigurationPtr>,
    pub NeAACDecSetConfiguration: Option<unsafe extern "C" fn(_:
                                                                  NeAACDecHandle,
                                                              _:
                                                                  NeAACDecConfigurationPtr)
                                             -> libc::c_uchar>,
    pub NeAACDecOpen: Option<unsafe extern "C" fn() -> NeAACDecHandle>,
    pub NeAACDecClose: Option<unsafe extern "C" fn(_: NeAACDecHandle) -> ()>,
    pub NeAACDecInit: Option<unsafe extern "C" fn(_: NeAACDecHandle,
                                                  _: *mut libc::c_uchar,
                                                  _: libc::c_ulong,
                                                  _: *mut libc::c_ulong,
                                                  _: *mut libc::c_uchar)
                                 -> libc::c_long>,
    pub NeAACDecInit2: Option<unsafe extern "C" fn(_: NeAACDecHandle,
                                                   _: *mut libc::c_uchar,
                                                   _: libc::c_ulong,
                                                   _: *mut libc::c_ulong,
                                                   _: *mut libc::c_uchar)
                                  -> libc::c_char>,
    pub NeAACDecDecode: Option<unsafe extern "C" fn(_: NeAACDecHandle,
                                                    _: *mut NeAACDecFrameInfo,
                                                    _: *mut libc::c_uchar,
                                                    _: libc::c_ulong)
                                   -> *mut libc::c_void>,
    pub NeAACDecGetErrorMessage: Option<unsafe extern "C" fn(_: libc::c_uchar)
                                            -> *mut libc::c_char>,
}
pub type NeAACDecHandle = *mut libc::c_void;
pub type NeAACDecConfigurationPtr = *mut NeAACDecConfiguration;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct NeAACDecConfiguration {
    pub defObjectType: libc::c_uchar,
    pub defSampleRate: libc::c_ulong,
    pub outputFormat: libc::c_uchar,
    pub downMatrix: libc::c_uchar,
    pub useOldADTSFormat: libc::c_uchar,
    pub dontUpSampleImplicitSBR: libc::c_uchar,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct chunk_table {
    pub sample: u32_t,
    pub offset: u32_t,
}
static mut a: *mut faad = 0 as *const faad as *mut faad;
// minimal code for mp4 file parsing to extract audio config and find media data
// adapted from faad2/common/mp4ff
#[no_mangle]
pub unsafe extern "C" fn mp4_desc_length(mut buf: *mut *mut u8_t) -> u32_t {
    let mut b: u8_t = 0;
    let mut num_bytes: u8_t = 0 as libc::c_int as u8_t;
    let mut length: u32_t = 0 as libc::c_int as u32_t;
    loop  {
        b = **buf;
        *buf = (*buf).offset(1 as libc::c_int as isize);
        num_bytes = num_bytes.wrapping_add(1);
        length =
            length << 7 as libc::c_int |
                (b as libc::c_int & 0x7f as libc::c_int) as libc::c_uint;
        if !(b as libc::c_int & 0x80 as libc::c_int != 0 &&
                 (num_bytes as libc::c_int) < 4 as libc::c_int) {
            break ;
        }
    }
    return length;
}
// read mp4 header to extract config data
unsafe extern "C" fn read_mp4_header(mut samplerate_p: *mut libc::c_ulong,
                                     mut channels_p: *mut libc::c_uchar)
 -> libc::c_int {
    let mut bytes: size_t =
        if _buf_used(streambuf) < _buf_cont_read(streambuf) {
            _buf_used(streambuf)
        } else { _buf_cont_read(streambuf) } as size_t;
    let mut type_0: [libc::c_char; 5] = [0; 5];
    let mut len: u32_t = 0;
    while bytes >= 8 as libc::c_int as libc::c_ulong {
        // count trak to find the first playable one
        static mut trak: libc::c_uint = 0;
        static mut play: libc::c_uint = 0;
        let mut consume: u32_t = 0;
        len = unpackN((*streambuf).readp as *mut u32_t);
        memcpy(type_0.as_mut_ptr() as *mut libc::c_void,
               (*streambuf).readp.offset(4 as libc::c_int as isize) as
                   *const libc::c_void, 4 as libc::c_int as libc::c_ulong);
        type_0[4 as libc::c_int as usize] = '\u{0}' as i32 as libc::c_char;
        if strcmp(type_0.as_mut_ptr(),
                  b"moov\x00" as *const u8 as *const libc::c_char) == 0 {
            trak = 0 as libc::c_int as libc::c_uint;
            play = 0 as libc::c_int as libc::c_uint
        }
        if strcmp(type_0.as_mut_ptr(),
                  b"trak\x00" as *const u8 as *const libc::c_char) == 0 {
            trak = trak.wrapping_add(1)
        }
        // extract audio config from within esds and pass to DecInit2
        if strcmp(type_0.as_mut_ptr(),
                  b"esds\x00" as *const u8 as *const libc::c_char) == 0 &&
               bytes > len as libc::c_ulong {
            let mut config_len: libc::c_uint = 0;
            let mut ptr: *mut u8_t =
                (*streambuf).readp.offset(12 as libc::c_int as isize);
            let fresh0 = ptr;
            ptr = ptr.offset(1);
            if *fresh0 as libc::c_int == 0x3 as libc::c_int {
                mp4_desc_length(&mut ptr);
                ptr = ptr.offset(4 as libc::c_int as isize)
            } else { ptr = ptr.offset(3 as libc::c_int as isize) }
            mp4_desc_length(&mut ptr);
            ptr = ptr.offset(13 as libc::c_int as isize);
            let fresh1 = ptr;
            ptr = ptr.offset(1);
            if *fresh1 as libc::c_int != 0x5 as libc::c_int {
                if loglevel as libc::c_uint >=
                       lWARN as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d error parsing esds\n\x00" as *const u8
                                 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 16],
                                                       &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                             146 as libc::c_int);
                }
                return -(1 as libc::c_int)
            }
            config_len = mp4_desc_length(&mut ptr);
            if (*a).NeAACDecInit2.expect("non-null function pointer")((*a).hAac,
                                                                      ptr,
                                                                      config_len
                                                                          as
                                                                          libc::c_ulong,
                                                                      samplerate_p,
                                                                      channels_p)
                   as libc::c_int == 0 as libc::c_int {
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d playable aac track: %u\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 16],
                                                       &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                             151 as libc::c_int, trak);
                }
                play = trak
            }
        }
        // extract the total number of samples from stts
        if strcmp(type_0.as_mut_ptr(),
                  b"stts\x00" as *const u8 as *const libc::c_char) == 0 &&
               bytes > len as libc::c_ulong {
            let mut i: u32_t = 0;
            let mut ptr_0: *mut u8_t =
                (*streambuf).readp.offset(12 as libc::c_int as isize);
            let mut entries: u32_t = unpackN(ptr_0 as *mut u32_t);
            ptr_0 = ptr_0.offset(4 as libc::c_int as isize);
            i = 0 as libc::c_int as u32_t;
            while i < entries {
                let mut count: u32_t = unpackN(ptr_0 as *mut u32_t);
                let mut size: u32_t =
                    unpackN(ptr_0.offset(4 as libc::c_int as isize) as
                                *mut u32_t);
                (*a).sttssamples =
                    ((*a).sttssamples as
                         libc::c_ulong).wrapping_add(count.wrapping_mul(size)
                                                         as libc::c_ulong) as
                        u64_t as u64_t;
                ptr_0 = ptr_0.offset(8 as libc::c_int as isize);
                i = i.wrapping_add(1)
            }
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d total number of samples contained in stts: %lu\n\x00"
                             as *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 16],
                                                   &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                         168 as libc::c_int, (*a).sttssamples);
            }
        }
        // stash sample to chunk info, assume it comes before stco
        if strcmp(type_0.as_mut_ptr(),
                  b"stsc\x00" as *const u8 as *const libc::c_char) == 0 &&
               bytes > len as libc::c_ulong && (*a).chunkinfo.is_null() {
            (*a).stsc =
                malloc(len.wrapping_sub(12 as libc::c_int as libc::c_uint) as
                           libc::c_ulong);
            if (*a).stsc.is_null() {
                if loglevel as libc::c_uint >=
                       lWARN as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d malloc fail\n\x00" as *const u8 as
                                 *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 16],
                                                       &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                             175 as libc::c_int);
                }
                return -(1 as libc::c_int)
            }
            memcpy((*a).stsc,
                   (*streambuf).readp.offset(12 as libc::c_int as isize) as
                       *const libc::c_void,
                   len.wrapping_sub(12 as libc::c_int as libc::c_uint) as
                       libc::c_ulong);
        }
        // build offsets table from stco and stored stsc
        if strcmp(type_0.as_mut_ptr(),
                  b"stco\x00" as *const u8 as *const libc::c_char) == 0 &&
               bytes > len as libc::c_ulong && play == trak {
            let mut i_0: u32_t = 0;
            // extract chunk offsets
            let mut ptr_1: *mut u8_t =
                (*streambuf).readp.offset(12 as libc::c_int as isize);
            let mut entries_0: u32_t = unpackN(ptr_1 as *mut u32_t);
            ptr_1 = ptr_1.offset(4 as libc::c_int as isize);
            (*a).chunkinfo =
                malloc((::std::mem::size_of::<chunk_table>() as
                            libc::c_ulong).wrapping_mul(entries_0.wrapping_add(1
                                                                                   as
                                                                                   libc::c_int
                                                                                   as
                                                                                   libc::c_uint)
                                                            as libc::c_ulong))
                    as *mut chunk_table;
            if (*a).chunkinfo.is_null() {
                if loglevel as libc::c_uint >=
                       lWARN as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d malloc fail\n\x00" as *const u8 as
                                 *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 16],
                                                       &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                             190 as libc::c_int);
                }
                return -(1 as libc::c_int)
            }
            i_0 = 0 as libc::c_int as u32_t;
            while i_0 < entries_0 {
                (*(*a).chunkinfo.offset(i_0 as isize)).offset =
                    unpackN(ptr_1 as *mut u32_t);
                (*(*a).chunkinfo.offset(i_0 as isize)).sample =
                    0 as libc::c_int as u32_t;
                ptr_1 = ptr_1.offset(4 as libc::c_int as isize);
                i_0 = i_0.wrapping_add(1)
            }
            (*(*a).chunkinfo.offset(i_0 as isize)).sample =
                0 as libc::c_int as u32_t;
            (*(*a).chunkinfo.offset(i_0 as isize)).offset =
                0 as libc::c_int as u32_t;
            // fill in first sample id for each chunk from stored stsc
            if !(*a).stsc.is_null() {
                let mut stsc_entries: u32_t =
                    unpackN((*a).stsc as *mut u32_t);
                let mut sample: u32_t = 0 as libc::c_int as u32_t;
                let mut last: u32_t = 0 as libc::c_int as u32_t;
                let mut last_samples: u32_t = 0 as libc::c_int as u32_t;
                let mut ptr_2: *mut u8_t =
                    ((*a).stsc as
                         *mut u8_t).offset(4 as libc::c_int as isize);
                loop  {
                    let fresh2 = stsc_entries;
                    stsc_entries = stsc_entries.wrapping_sub(1);
                    if !(fresh2 != 0) { break ; }
                    let mut first: u32_t = unpackN(ptr_2 as *mut u32_t);
                    let mut samples: u32_t =
                        unpackN(ptr_2.offset(4 as libc::c_int as isize) as
                                    *mut u32_t);
                    if last != 0 {
                        i_0 =
                            last.wrapping_sub(1 as libc::c_int as
                                                  libc::c_uint);
                        while i_0 <
                                  first.wrapping_sub(1 as libc::c_int as
                                                         libc::c_uint) {
                            (*(*a).chunkinfo.offset(i_0 as isize)).sample =
                                sample;
                            sample =
                                (sample as
                                     libc::c_uint).wrapping_add(last_samples)
                                    as u32_t as u32_t;
                            i_0 = i_0.wrapping_add(1)
                        }
                    }
                    if stsc_entries == 0 as libc::c_int as libc::c_uint {
                        i_0 =
                            first.wrapping_sub(1 as libc::c_int as
                                                   libc::c_uint);
                        while i_0 < entries_0 {
                            (*(*a).chunkinfo.offset(i_0 as isize)).sample =
                                sample;
                            sample =
                                (sample as libc::c_uint).wrapping_add(samples)
                                    as u32_t as u32_t;
                            i_0 = i_0.wrapping_add(1)
                        }
                    }
                    last = first;
                    last_samples = samples;
                    ptr_2 = ptr_2.offset(12 as libc::c_int as isize)
                }
                free((*a).stsc);
                (*a).stsc = 0 as *mut libc::c_void
            }
        }
        // found media data, advance to start of first chunk and return
        if strcmp(type_0.as_mut_ptr(),
                  b"mdat\x00" as *const u8 as *const libc::c_char) == 0 {
            _buf_inc_readp(streambuf, 8 as libc::c_int as libc::c_uint);
            (*a).pos =
                ((*a).pos as
                     libc::c_uint).wrapping_add(8 as libc::c_int as
                                                    libc::c_uint) as u32_t as
                    u32_t;
            bytes =
                (bytes as
                     libc::c_ulong).wrapping_sub(8 as libc::c_int as
                                                     libc::c_ulong) as size_t
                    as size_t;
            if play != 0 {
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d type: mdat len: %u pos: %u\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 16],
                                                       &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                             236 as libc::c_int, len, (*a).pos);
                }
                if !(*a).chunkinfo.is_null() &&
                       (*(*a).chunkinfo.offset(0 as libc::c_int as
                                                   isize)).offset > (*a).pos {
                    let mut skip: u32_t =
                        (*(*a).chunkinfo.offset(0 as libc::c_int as
                                                    isize)).offset.wrapping_sub((*a).pos);
                    if loglevel as libc::c_uint >=
                           lDEBUG as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d skipping: %u\n\x00" as *const u8
                                     as *const libc::c_char, logtime(),
                                 (*::std::mem::transmute::<&[u8; 16],
                                                           &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                                 239 as libc::c_int, skip);
                    }
                    if skip as libc::c_ulong <= bytes {
                        _buf_inc_readp(streambuf, skip);
                        (*a).pos =
                            ((*a).pos as libc::c_uint).wrapping_add(skip) as
                                u32_t as u32_t
                    } else { (*a).consume = skip }
                }
                (*a).nextchunk = 1 as libc::c_int as u32_t;
                (*a).sample = (*a).nextchunk;
                return 1 as libc::c_int
            } else {
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d type: mdat len: %u, no playable track found\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 16],
                                                       &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                             250 as libc::c_int, len);
                }
                return -(1 as libc::c_int)
            }
        }
        // parse key-value atoms within ilst ---- entries to get encoder padding within iTunSMPB entry for gapless
        if strcmp(type_0.as_mut_ptr(),
                  b"----\x00" as *const u8 as *const libc::c_char) == 0 &&
               bytes > len as libc::c_ulong {
            let mut ptr_3: *mut u8_t =
                (*streambuf).readp.offset(8 as libc::c_int as isize);
            let mut remain: u32_t =
                len.wrapping_sub(8 as libc::c_int as libc::c_uint);
            let mut size_0: u32_t = 0;
            if memcmp(ptr_3.offset(4 as libc::c_int as isize) as
                          *const libc::c_void,
                      b"mean\x00" as *const u8 as *const libc::c_char as
                          *const libc::c_void,
                      4 as libc::c_int as libc::c_ulong) == 0 &&
                   {
                       size_0 = unpackN(ptr_3 as *mut u32_t);
                       (size_0) < remain
                   } {
                ptr_3 = ptr_3.offset(size_0 as isize);
                remain =
                    (remain as libc::c_uint).wrapping_sub(size_0) as u32_t as
                        u32_t
            }
            if memcmp(ptr_3.offset(4 as libc::c_int as isize) as
                          *const libc::c_void,
                      b"name\x00" as *const u8 as *const libc::c_char as
                          *const libc::c_void,
                      4 as libc::c_int as libc::c_ulong) == 0 &&
                   {
                       size_0 = unpackN(ptr_3 as *mut u32_t);
                       (size_0) < remain
                   } &&
                   memcmp(ptr_3.offset(12 as libc::c_int as isize) as
                              *const libc::c_void,
                          b"iTunSMPB\x00" as *const u8 as *const libc::c_char
                              as *const libc::c_void,
                          8 as libc::c_int as libc::c_ulong) == 0 {
                ptr_3 = ptr_3.offset(size_0 as isize);
                remain =
                    (remain as libc::c_uint).wrapping_sub(size_0) as u32_t as
                        u32_t
            }
            if memcmp(ptr_3.offset(4 as libc::c_int as isize) as
                          *const libc::c_void,
                      b"data\x00" as *const u8 as *const libc::c_char as
                          *const libc::c_void,
                      4 as libc::c_int as libc::c_ulong) == 0 &&
                   remain >
                       (16 as libc::c_int + 48 as libc::c_int) as libc::c_uint
               {
                // data is stored as hex strings: 0 start end samples
                let mut b: u32_t = 0;
                let mut c: u32_t = 0;
                let mut d: u64_t = 0;
                if sscanf(ptr_3.offset(16 as libc::c_int as isize) as
                              *const libc::c_char,
                          b"%x %x %x %lx\x00" as *const u8 as
                              *const libc::c_char, &mut b as *mut u32_t,
                          &mut b as *mut u32_t, &mut c as *mut u32_t,
                          &mut d as *mut u64_t) == 4 as libc::c_int {
                    if loglevel as libc::c_uint >=
                           lDEBUG as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d iTunSMPB start: %u end: %u samples: %lu\n\x00"
                                     as *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 16],
                                                           &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                                 269 as libc::c_int, b, c, d);
                    }
                    if (*a).sttssamples != 0 &&
                           (*a).sttssamples <
                               (b.wrapping_add(c) as
                                    libc::c_ulong).wrapping_add(d) {
                        if loglevel as libc::c_uint >=
                               lDEBUG as libc::c_int as libc::c_uint {
                            logprint(b"%s %s:%d reducing samples as stts count is less\n\x00"
                                         as *const u8 as *const libc::c_char,
                                     logtime(),
                                     (*::std::mem::transmute::<&[u8; 16],
                                                               &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                                     271 as libc::c_int);
                        }
                        d =
                            (*a).sttssamples.wrapping_sub(b.wrapping_add(c) as
                                                              libc::c_ulong)
                    }
                    (*a).skip = b;
                    (*a).samples = d
                }
            }
        }
        // default to consuming entire box
        consume = len;
        // read into these boxes so reduce consume
        if strcmp(type_0.as_mut_ptr(),
                  b"moov\x00" as *const u8 as *const libc::c_char) == 0 ||
               strcmp(type_0.as_mut_ptr(),
                      b"trak\x00" as *const u8 as *const libc::c_char) == 0 ||
               strcmp(type_0.as_mut_ptr(),
                      b"mdia\x00" as *const u8 as *const libc::c_char) == 0 ||
               strcmp(type_0.as_mut_ptr(),
                      b"minf\x00" as *const u8 as *const libc::c_char) == 0 ||
               strcmp(type_0.as_mut_ptr(),
                      b"stbl\x00" as *const u8 as *const libc::c_char) == 0 ||
               strcmp(type_0.as_mut_ptr(),
                      b"udta\x00" as *const u8 as *const libc::c_char) == 0 ||
               strcmp(type_0.as_mut_ptr(),
                      b"ilst\x00" as *const u8 as *const libc::c_char) == 0 {
            consume = 8 as libc::c_int as u32_t
        }
        // special cases which mix mix data in the enclosing box which we want to read into
        if strcmp(type_0.as_mut_ptr(),
                  b"stsd\x00" as *const u8 as *const libc::c_char) == 0 {
            consume = 16 as libc::c_int as u32_t
        }
        if strcmp(type_0.as_mut_ptr(),
                  b"mp4a\x00" as *const u8 as *const libc::c_char) == 0 {
            consume = 36 as libc::c_int as u32_t
        }
        if strcmp(type_0.as_mut_ptr(),
                  b"meta\x00" as *const u8 as *const libc::c_char) == 0 {
            consume = 12 as libc::c_int as u32_t
        }
        // consume rest of box if it has been parsed (all in the buffer) or is not one we want to parse
        if bytes >= consume as libc::c_ulong {
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d type: %s len: %u consume: %u\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 16],
                                                   &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                         295 as libc::c_int, type_0.as_mut_ptr(), len,
                         consume);
            }
            _buf_inc_readp(streambuf, consume);
            (*a).pos =
                ((*a).pos as libc::c_uint).wrapping_add(consume) as u32_t as
                    u32_t;
            bytes =
                (bytes as
                     libc::c_ulong).wrapping_sub(consume as libc::c_ulong) as
                    size_t as size_t
        } else {
            if strcmp(type_0.as_mut_ptr(),
                      b"esds\x00" as *const u8 as *const libc::c_char) == 0 ||
                   strcmp(type_0.as_mut_ptr(),
                          b"stts\x00" as *const u8 as *const libc::c_char) ==
                       0 ||
                   strcmp(type_0.as_mut_ptr(),
                          b"stsc\x00" as *const u8 as *const libc::c_char) ==
                       0 ||
                   strcmp(type_0.as_mut_ptr(),
                          b"stco\x00" as *const u8 as *const libc::c_char) ==
                       0 ||
                   strcmp(type_0.as_mut_ptr(),
                          b"----\x00" as *const u8 as *const libc::c_char) ==
                       0 {
                break ;
            }
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d type: %s len: %u consume: %u - partial consume: %u\n\x00"
                             as *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 16],
                                                   &[libc::c_char; 16]>(b"read_mp4_header\x00")).as_ptr(),
                         301 as libc::c_int, type_0.as_mut_ptr(), len,
                         consume, bytes);
            }
            _buf_inc_readp(streambuf, bytes as libc::c_uint);
            (*a).pos =
                ((*a).pos as libc::c_ulong).wrapping_add(bytes) as u32_t as
                    u32_t;
            (*a).consume =
                (consume as libc::c_ulong).wrapping_sub(bytes) as u32_t;
            break ;
        }
    }
    return 0 as libc::c_int;
}
unsafe extern "C" fn faad_decode() -> decode_state {
    let mut bytes_total: size_t = 0;
    let mut bytes_wrap: size_t = 0;
    let mut info: NeAACDecFrameInfo =
        NeAACDecFrameInfo{bytesconsumed: 0,
                          samples: 0,
                          channels: 0,
                          error: 0,
                          samplerate: 0,
                          sbr: 0,
                          object_type: 0,
                          header_type: 0,
                          num_front_channels: 0,
                          num_side_channels: 0,
                          num_back_channels: 0,
                          num_lfe_channels: 0,
                          channel_position: [0; 64],
                          ps: 0,};
    let mut iptr: *mut s32_t = 0 as *mut s32_t;
    let mut endstream: bool = false;
    let mut frames: frames_t = 0;
    pthread_mutex_lock(&mut (*streambuf).mutex);
    bytes_total = _buf_used(streambuf) as size_t;
    bytes_wrap =
        if bytes_total < _buf_cont_read(streambuf) as libc::c_ulong {
            bytes_total
        } else { _buf_cont_read(streambuf) as libc::c_ulong };
    if stream.state as libc::c_uint <=
           DISCONNECT as libc::c_int as libc::c_uint && bytes_total == 0 {
        pthread_mutex_unlock(&mut (*streambuf).mutex);
        return DECODE_COMPLETE
    }
    if (*a).consume != 0 {
        let mut consume: u32_t =
            if ((*a).consume as libc::c_ulong) < bytes_wrap {
                (*a).consume as libc::c_ulong
            } else { bytes_wrap } as u32_t;
        if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d consume: %u of %u\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 12],
                                               &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                     333 as libc::c_int, consume, (*a).consume);
        }
        _buf_inc_readp(streambuf, consume);
        (*a).pos =
            ((*a).pos as libc::c_uint).wrapping_add(consume) as u32_t as
                u32_t;
        (*a).consume =
            ((*a).consume as libc::c_uint).wrapping_sub(consume) as u32_t as
                u32_t;
        pthread_mutex_unlock(&mut (*streambuf).mutex);
        return DECODE_RUNNING
    }
    if decode.new_stream {
        let mut found: libc::c_int = 0 as libc::c_int;
        static mut channels: libc::c_uchar = 0;
        static mut samplerate: libc::c_ulong = 0;
        if (*a).type_0 as libc::c_int == '2' as i32 {
            // adts stream - seek for header
            while bytes_wrap >= 2 as libc::c_int as libc::c_ulong &&
                      (*(*streambuf).readp as libc::c_int !=
                           0xff as libc::c_int ||
                           *(*streambuf).readp.offset(1 as libc::c_int as
                                                          isize) as
                               libc::c_int & 0xf6 as libc::c_int !=
                               0xf0 as libc::c_int) {
                _buf_inc_readp(streambuf, 1 as libc::c_int as libc::c_uint);
                bytes_total = bytes_total.wrapping_sub(1);
                bytes_wrap = bytes_wrap.wrapping_sub(1)
            }
            if bytes_wrap >= 2 as libc::c_int as libc::c_ulong {
                let mut n: libc::c_long =
                    (*a).NeAACDecInit.expect("non-null function pointer")((*a).hAac,
                                                                          (*streambuf).readp,
                                                                          bytes_wrap,
                                                                          &mut samplerate,
                                                                          &mut channels);
                if n < 0 as libc::c_int as libc::c_long {
                    found = -(1 as libc::c_int)
                } else {
                    _buf_inc_readp(streambuf, n as libc::c_uint);
                    found = 1 as libc::c_int
                }
            }
        } else {
            // mp4 - read header
            found = read_mp4_header(&mut samplerate, &mut channels)
        }
        if found == 1 as libc::c_int {
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d samplerate: %u channels: %u\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 12],
                                                   &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                         373 as libc::c_int, samplerate,
                         channels as libc::c_int);
            }
            bytes_total = _buf_used(streambuf) as size_t;
            bytes_wrap =
                if bytes_total < _buf_cont_read(streambuf) as libc::c_ulong {
                    bytes_total
                } else { _buf_cont_read(streambuf) as libc::c_ulong };
            pthread_mutex_lock(&mut (*outputbuf).mutex);
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d setting track_start\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 12],
                                                   &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                         378 as libc::c_int);
            }
            output.next_sample_rate =
                decode_newstream(samplerate as libc::c_uint,
                                 output.supported_rates.as_mut_ptr());
            output.track_start = (*outputbuf).writep;
            if output.fade_mode as u64 != 0 {
                _checkfade(1 as libc::c_int != 0);
            }
            decode.new_stream = 0 as libc::c_int != 0;
            pthread_mutex_unlock(&mut (*outputbuf).mutex);
        } else if found == -(1 as libc::c_int) {
            if loglevel as libc::c_uint >=
                   lWARN as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d error reading stream header\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 12],
                                                   &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                         388 as libc::c_int);
            }
            pthread_mutex_unlock(&mut (*streambuf).mutex);
            return DECODE_ERROR
        } else {
            // not finished header parsing come back next time
            pthread_mutex_unlock(&mut (*streambuf).mutex);
            return DECODE_RUNNING
        }
    }
    if bytes_wrap < 2048 as libc::c_int as libc::c_ulong &&
           bytes_total > 2048 as libc::c_int as libc::c_ulong {
        // make a local copy of frames which may have wrapped round the end of streambuf
        let mut buf: [u8_t; 2048] = [0; 2048];
        memcpy(buf.as_mut_ptr() as *mut libc::c_void,
               (*streambuf).readp as *const libc::c_void, bytes_wrap);
        memcpy(buf.as_mut_ptr().offset(bytes_wrap as isize) as
                   *mut libc::c_void, (*streambuf).buf as *const libc::c_void,
               (2048 as libc::c_int as
                    libc::c_ulong).wrapping_sub(bytes_wrap));
        iptr =
            (*a).NeAACDecDecode.expect("non-null function pointer")((*a).hAac,
                                                                    &mut info,
                                                                    buf.as_mut_ptr(),
                                                                    2048 as
                                                                        libc::c_int
                                                                        as
                                                                        libc::c_ulong)
                as *mut s32_t
    } else {
        iptr =
            (*a).NeAACDecDecode.expect("non-null function pointer")((*a).hAac,
                                                                    &mut info,
                                                                    (*streambuf).readp,
                                                                    bytes_wrap)
                as *mut s32_t
    }
    if info.error != 0 {
        if loglevel as libc::c_uint >= lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d error: %u %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 12],
                                               &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                     415 as libc::c_int, info.error as libc::c_int,
                     (*a).NeAACDecGetErrorMessage.expect("non-null function pointer")(info.error));
        }
    }
    endstream = 0 as libc::c_int != 0;
    // mp4 end of chunk - skip to next offset
    if !(*a).chunkinfo.is_null() &&
           (*(*a).chunkinfo.offset((*a).nextchunk as isize)).offset != 0 &&
           {
               let fresh3 = (*a).sample;
               (*a).sample = (*a).sample.wrapping_add(1);
               (fresh3) ==
                   (*(*a).chunkinfo.offset((*a).nextchunk as isize)).sample
           } {
        if (*(*a).chunkinfo.offset((*a).nextchunk as isize)).offset > (*a).pos
           {
            let mut skip: u32_t =
                (*(*a).chunkinfo.offset((*a).nextchunk as
                                            isize)).offset.wrapping_sub((*a).pos);
            if skip as libc::c_ulong != info.bytesconsumed {
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d skipping to next chunk pos: %u consumed: %u != skip: %u\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 12],
                                                       &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                             426 as libc::c_int, (*a).pos, info.bytesconsumed,
                             skip);
                }
            }
            if bytes_total >= skip as libc::c_ulong {
                _buf_inc_readp(streambuf, skip);
                (*a).pos =
                    ((*a).pos as libc::c_uint).wrapping_add(skip) as u32_t as
                        u32_t
            } else { (*a).consume = skip }
            (*a).nextchunk = (*a).nextchunk.wrapping_add(1)
        } else {
            logprint(b"%s %s:%d error: need to skip backwards!\n\x00" as
                         *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 12],
                                               &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                     436 as libc::c_int);
            endstream = 1 as libc::c_int != 0
        }
        // adts and mp4 when not at end of chunk 
    } else if info.bytesconsumed != 0 as libc::c_int as libc::c_ulong {
        _buf_inc_readp(streambuf, info.bytesconsumed as libc::c_uint);
        (*a).pos =
            ((*a).pos as libc::c_ulong).wrapping_add(info.bytesconsumed) as
                u32_t as u32_t
        // error which doesn't advance streambuf - end
    } else { endstream = 1 as libc::c_int != 0 }
    pthread_mutex_unlock(&mut (*streambuf).mutex);
    if endstream {
        if loglevel as libc::c_uint >= lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d unable to decode further\n\x00" as *const u8
                         as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 12],
                                               &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                     454 as libc::c_int);
        }
        return DECODE_ERROR
    }
    if info.samples == 0 {
        (*a).empty = 1 as libc::c_int != 0;
        return DECODE_RUNNING
    }
    frames =
        info.samples.wrapping_div(info.channels as libc::c_ulong) as frames_t;
    if (*a).skip != 0 {
        let mut skip_0: u32_t = 0;
        if (*a).empty {
            (*a).empty = 0 as libc::c_int != 0;
            (*a).skip =
                ((*a).skip as libc::c_uint).wrapping_sub(frames) as u32_t as
                    u32_t;
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d gapless: first frame empty, skipped %u frames at start\n\x00"
                             as *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 12],
                                                   &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                         470 as libc::c_int, frames);
            }
        }
        skip_0 = if frames < (*a).skip { frames } else { (*a).skip };
        if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d gapless: skipping %u frames at start\n\x00" as
                         *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 12],
                                               &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                     473 as libc::c_int, skip_0);
        }
        frames =
            (frames as libc::c_uint).wrapping_sub(skip_0) as frames_t as
                frames_t;
        (*a).skip =
            ((*a).skip as libc::c_uint).wrapping_sub(skip_0) as u32_t as
                u32_t;
        iptr =
            iptr.offset(skip_0.wrapping_mul(info.channels as libc::c_uint) as
                            isize)
    }
    if (*a).samples != 0 {
        if (*a).samples < frames as libc::c_ulong {
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d gapless: trimming %u frames from end\n\x00"
                             as *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 12],
                                                   &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                         481 as libc::c_int,
                         (frames as
                              libc::c_ulong).wrapping_sub((*a).samples));
            }
            frames = (*a).samples as frames_t
        }
        (*a).samples =
            ((*a).samples as
                 libc::c_ulong).wrapping_sub(frames as libc::c_ulong) as u64_t
                as u64_t
    }
    if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d write %u frames\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 12],
                                           &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                 487 as libc::c_int, frames);
    }
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    while frames > 0 as libc::c_int as libc::c_uint {
        let mut f: frames_t = 0;
        let mut count: frames_t = 0;
        let mut optr: *mut s32_t = 0 as *mut s32_t;
        f =
            _buf_cont_write(outputbuf).wrapping_div(8 as libc::c_int as
                                                        libc::c_uint);
        optr = (*outputbuf).writep as *mut s32_t;
        f = if f < frames { f } else { frames };
        count = f;
        if info.channels as libc::c_int == 2 as libc::c_int {
            loop  {
                let fresh4 = count;
                count = count.wrapping_sub(1);
                if !(fresh4 != 0) { break ; }
                let fresh5 = iptr;
                iptr = iptr.offset(1);
                let fresh6 = optr;
                optr = optr.offset(1);
                *fresh6 = *fresh5 << 8 as libc::c_int;
                let fresh7 = iptr;
                iptr = iptr.offset(1);
                let fresh8 = optr;
                optr = optr.offset(1);
                *fresh8 = *fresh7 << 8 as libc::c_int
            }
        } else if info.channels as libc::c_int == 1 as libc::c_int {
            loop  {
                let fresh9 = count;
                count = count.wrapping_sub(1);
                if !(fresh9 != 0) { break ; }
                let fresh10 = optr;
                optr = optr.offset(1);
                *fresh10 = *iptr << 8 as libc::c_int;
                let fresh11 = iptr;
                iptr = iptr.offset(1);
                let fresh12 = optr;
                optr = optr.offset(1);
                *fresh12 = *fresh11 << 8 as libc::c_int
            }
        } else if loglevel as libc::c_uint >=
                      lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d unsupported number of channels\n\x00" as
                         *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 12],
                                               &[libc::c_char; 12]>(b"faad_decode\x00")).as_ptr(),
                     519 as libc::c_int);
        }
        frames =
            (frames as libc::c_uint).wrapping_sub(f) as frames_t as frames_t;
        _buf_inc_writep(outputbuf,
                        f.wrapping_mul(8 as libc::c_int as libc::c_uint));
    }
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
    return DECODE_RUNNING;
}
unsafe extern "C" fn faad_open(mut size: u8_t, mut rate: u8_t, mut chan: u8_t,
                               mut endianness: u8_t) {
    let mut conf: NeAACDecConfigurationPtr = 0 as *mut NeAACDecConfiguration;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d opening %s stream\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 10],
                                           &[libc::c_char; 10]>(b"faad_open\x00")).as_ptr(),
                 541 as libc::c_int,
                 if size as libc::c_int == '2' as i32 {
                     b"adts\x00" as *const u8 as *const libc::c_char
                 } else { b"mp4\x00" as *const u8 as *const libc::c_char });
    }
    (*a).type_0 = size;
    (*a).nextchunk = 0 as libc::c_int as u32_t;
    (*a).sample = (*a).nextchunk;
    (*a).consume = (*a).sample;
    (*a).pos = (*a).consume;
    if !(*a).chunkinfo.is_null() {
        free((*a).chunkinfo as *mut libc::c_void);
    }
    if !(*a).stsc.is_null() { free((*a).stsc); }
    (*a).chunkinfo = 0 as *mut chunk_table;
    (*a).stsc = 0 as *mut libc::c_void;
    (*a).skip = 0 as libc::c_int as u32_t;
    (*a).samples = 0 as libc::c_int as u64_t;
    (*a).sttssamples = 0 as libc::c_int as u64_t;
    (*a).empty = 0 as libc::c_int != 0;
    if !(*a).hAac.is_null() {
        (*a).NeAACDecClose.expect("non-null function pointer")((*a).hAac);
    }
    (*a).hAac = (*a).NeAACDecOpen.expect("non-null function pointer")();
    conf =
        (*a).NeAACDecGetCurrentConfiguration.expect("non-null function pointer")((*a).hAac);
    (*conf).outputFormat = 2 as libc::c_int as libc::c_uchar;
    (*conf).downMatrix = 1 as libc::c_int as libc::c_uchar;
    if (*a).NeAACDecSetConfiguration.expect("non-null function pointer")((*a).hAac,
                                                                         conf)
           == 0 {
        if loglevel as libc::c_uint >= lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d error setting config\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 10],
                                               &[libc::c_char; 10]>(b"faad_open\x00")).as_ptr(),
                     570 as libc::c_int);
        }
    };
}
unsafe extern "C" fn faad_close() {
    (*a).NeAACDecClose.expect("non-null function pointer")((*a).hAac);
    (*a).hAac = 0 as *mut libc::c_void;
    if !(*a).chunkinfo.is_null() {
        free((*a).chunkinfo as *mut libc::c_void);
        (*a).chunkinfo = 0 as *mut chunk_table
    }
    if !(*a).stsc.is_null() {
        free((*a).stsc);
        (*a).stsc = 0 as *mut libc::c_void
    };
}
unsafe extern "C" fn load_faad() -> bool {
    let mut handle: *mut libc::c_void =
        dlopen(b"libfaad.so.2\x00" as *const u8 as *const libc::c_char,
               0x2 as libc::c_int);
    let mut err: *mut libc::c_char = 0 as *mut libc::c_char;
    if handle.is_null() {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d dlerror: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 10],
                                               &[libc::c_char; 10]>(b"load_faad\x00")).as_ptr(),
                     593 as libc::c_int, dlerror());
        }
        return 0 as libc::c_int != 0
    }
    (*a).NeAACDecGetCurrentConfiguration =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: NeAACDecHandle)
                                           ->
                                               NeAACDecConfigurationPtr>>(dlsym(handle,
                                                                                b"NeAACDecGetCurrentConfiguration\x00"
                                                                                    as
                                                                                    *const u8
                                                                                    as
                                                                                    *const libc::c_char));
    (*a).NeAACDecSetConfiguration =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: NeAACDecHandle,
                                                            _:
                                                                NeAACDecConfigurationPtr)
                                           ->
                                               libc::c_uchar>>(dlsym(handle,
                                                                     b"NeAACDecSetConfiguration\x00"
                                                                         as
                                                                         *const u8
                                                                         as
                                                                         *const libc::c_char));
    (*a).NeAACDecOpen =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn()
                                           ->
                                               NeAACDecHandle>>(dlsym(handle,
                                                                      b"NeAACDecOpen\x00"
                                                                          as
                                                                          *const u8
                                                                          as
                                                                          *const libc::c_char));
    (*a).NeAACDecClose =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: NeAACDecHandle)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"NeAACDecClose\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*a).NeAACDecInit =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: NeAACDecHandle,
                                                            _:
                                                                *mut libc::c_uchar,
                                                            _: libc::c_ulong,
                                                            _:
                                                                *mut libc::c_ulong,
                                                            _:
                                                                *mut libc::c_uchar)
                                           ->
                                               libc::c_long>>(dlsym(handle,
                                                                    b"NeAACDecInit\x00"
                                                                        as
                                                                        *const u8
                                                                        as
                                                                        *const libc::c_char));
    (*a).NeAACDecInit2 =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: NeAACDecHandle,
                                                            _:
                                                                *mut libc::c_uchar,
                                                            _: libc::c_ulong,
                                                            _:
                                                                *mut libc::c_ulong,
                                                            _:
                                                                *mut libc::c_uchar)
                                           ->
                                               libc::c_char>>(dlsym(handle,
                                                                    b"NeAACDecInit2\x00"
                                                                        as
                                                                        *const u8
                                                                        as
                                                                        *const libc::c_char));
    (*a).NeAACDecDecode =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: NeAACDecHandle,
                                                            _:
                                                                *mut NeAACDecFrameInfo,
                                                            _:
                                                                *mut libc::c_uchar,
                                                            _: libc::c_ulong)
                                           ->
                                               *mut libc::c_void>>(dlsym(handle,
                                                                         b"NeAACDecDecode\x00"
                                                                             as
                                                                             *const u8
                                                                             as
                                                                             *const libc::c_char));
    (*a).NeAACDecGetErrorMessage =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: libc::c_uchar)
                                           ->
                                               *mut libc::c_char>>(dlsym(handle,
                                                                         b"NeAACDecGetErrorMessage\x00"
                                                                             as
                                                                             *const u8
                                                                             as
                                                                             *const libc::c_char));
    err = dlerror();
    if !err.is_null() {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d dlerror: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 10],
                                               &[libc::c_char; 10]>(b"load_faad\x00")).as_ptr(),
                     607 as libc::c_int, err);
        }
        return 0 as libc::c_int != 0
    }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d loaded libfaad.so.2\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 10],
                                           &[libc::c_char; 10]>(b"load_faad\x00")).as_ptr(),
                 611 as libc::c_int);
    }
    return 1 as libc::c_int != 0;
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
// output_pack.c
// output_vis.c
// dop.c
// codecs
#[no_mangle]
pub unsafe extern "C" fn register_faad() -> *mut codec {
    static mut ret: codec =
        unsafe {
            {
                let mut init =
                    codec{id: 'a' as i32 as libc::c_char,
                          types:
                              b"aac\x00" as *const u8 as *const libc::c_char
                                  as *mut libc::c_char,
                          min_read_bytes: 2048 as libc::c_int as libc::c_uint,
                          min_space: 20480 as libc::c_int as libc::c_uint,
                          open:
                              Some(faad_open as
                                       unsafe extern "C" fn(_: u8_t, _: u8_t,
                                                            _: u8_t, _: u8_t)
                                           -> ()),
                          close:
                              Some(faad_close as
                                       unsafe extern "C" fn() -> ()),
                          decode:
                              Some(faad_decode as
                                       unsafe extern "C" fn()
                                           -> decode_state),};
                init
            }
        };
    a = malloc(::std::mem::size_of::<faad>() as libc::c_ulong) as *mut faad;
    if a.is_null() { return 0 as *mut codec }
    (*a).hAac = 0 as *mut libc::c_void;
    (*a).chunkinfo = 0 as *mut chunk_table;
    (*a).stsc = 0 as *mut libc::c_void;
    if !load_faad() { return 0 as *mut codec }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d using faad to decode aac\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 14],
                                           &[libc::c_char; 14]>(b"register_faad\x00")).as_ptr(),
                 641 as libc::c_int);
    }
    return &mut ret;
}
