use ::libc;
extern "C" {
    #[no_mangle]
    fn _checkfade(_: bool);
    #[no_mangle]
    fn decode_newstream(sample_rate: libc::c_uint,
                        supported_rates: *mut libc::c_uint) -> libc::c_uint;
    #[no_mangle]
    fn _buf_inc_writep(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn _buf_inc_readp(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn _buf_cont_write(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_read(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_space(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_used(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn unpackN(src: *mut u32_t) -> u32_t;
    #[no_mangle]
    fn malloc(_: libc::c_ulong) -> *mut libc::c_void;
    #[no_mangle]
    fn free(__ptr: *mut libc::c_void);
    #[no_mangle]
    fn memcpy(_: *mut libc::c_void, _: *const libc::c_void, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memmove(_: *mut libc::c_void, _: *const libc::c_void, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memset(_: *mut libc::c_void, _: libc::c_int, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memcmp(_: *const libc::c_void, _: *const libc::c_void,
              _: libc::c_ulong) -> libc::c_int;
    #[no_mangle]
    fn dlopen(__file: *const libc::c_char, __mode: libc::c_int)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlsym(__handle: *mut libc::c_void, __name: *const libc::c_char)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlerror() -> *mut libc::c_char;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    static mut loglevel: log_level;
    #[no_mangle]
    static mut streambuf: *mut buffer;
    #[no_mangle]
    static mut outputbuf: *mut buffer;
    #[no_mangle]
    static mut stream: streamstate;
    #[no_mangle]
    static mut output: outputstate;
    #[no_mangle]
    static mut decode: decodestate;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type int32_t = __int32_t;
pub type u_int8_t = __uint8_t;
pub type u_int32_t = __uint32_t;
pub type u_int64_t = __uint64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type u8_t = u_int8_t;
pub type u32_t = u_int32_t;
pub type u64_t = u_int64_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type stream_state = libc::c_uint;
pub const RECV_HEADERS: stream_state = 7;
pub const SEND_HEADERS: stream_state = 6;
pub const STREAMING_HTTP: stream_state = 5;
pub const STREAMING_FILE: stream_state = 4;
pub const STREAMING_BUFFERING: stream_state = 3;
pub const STREAMING_WAIT: stream_state = 2;
pub const DISCONNECT: stream_state = 1;
pub const STOPPED: stream_state = 0;
pub type disconnect_code = libc::c_uint;
pub const TIMEOUT: disconnect_code = 4;
pub const UNREACHABLE: disconnect_code = 3;
pub const REMOTE_DISCONNECT: disconnect_code = 2;
pub const LOCAL_DISCONNECT: disconnect_code = 1;
pub const DISCONNECT_OK: disconnect_code = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct streamstate {
    pub state: stream_state,
    pub disconnect: disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: u32_t,
    pub meta_next: u32_t,
    pub meta_left: u32_t,
    pub meta_send: bool,
}
pub type decode_state = libc::c_uint;
pub const DECODE_ERROR: decode_state = 4;
pub const DECODE_COMPLETE: decode_state = 3;
pub const DECODE_RUNNING: decode_state = 2;
pub const DECODE_READY: decode_state = 1;
pub const DECODE_STOPPED: decode_state = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct decodestate {
    pub state: decode_state,
    pub new_stream: bool,
    pub mutex: pthread_mutex_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct codec {
    pub id: libc::c_char,
    pub types: *mut libc::c_char,
    pub min_read_bytes: libc::c_uint,
    pub min_space: libc::c_uint,
    pub open: Option<unsafe extern "C" fn(_: u8_t, _: u8_t, _: u8_t, _: u8_t)
                         -> ()>,
    pub close: Option<unsafe extern "C" fn() -> ()>,
    pub decode: Option<unsafe extern "C" fn() -> decode_state>,
}
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_RUNNING: output_state = 2;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
pub type mad_fixed_t = libc::c_int;
// local buffer used by decoder: FIXME merge with any other decoders needing one?
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mad {
    pub readbuf: *mut u8_t,
    pub readbuf_len: libc::c_uint,
    pub stream: mad_stream,
    pub frame: mad_frame,
    pub synth: mad_synth,
    pub last_error: mad_error,
    pub checktags: libc::c_int,
    pub consume: u32_t,
    pub skip: u32_t,
    pub samples: u64_t,
    pub padding: u32_t,
    pub mad_stream_init: Option<unsafe extern "C" fn(_: *mut mad_stream)
                                    -> ()>,
    pub mad_frame_init: Option<unsafe extern "C" fn(_: *mut mad_frame) -> ()>,
    pub mad_synth_init: Option<unsafe extern "C" fn(_: *mut mad_synth) -> ()>,
    pub mad_frame_finish: Option<unsafe extern "C" fn(_: *mut mad_frame)
                                     -> ()>,
    pub mad_stream_finish: Option<unsafe extern "C" fn(_: *mut mad_stream)
                                      -> ()>,
    pub mad_stream_buffer: Option<unsafe extern "C" fn(_: *mut mad_stream,
                                                       _:
                                                           *const libc::c_uchar,
                                                       _: libc::c_ulong)
                                      -> ()>,
    pub mad_frame_decode: Option<unsafe extern "C" fn(_: *mut mad_frame,
                                                      _: *mut mad_stream)
                                     -> libc::c_int>,
    pub mad_synth_frame: Option<unsafe extern "C" fn(_: *mut mad_synth,
                                                     _: *const mad_frame)
                                    -> ()>,
    pub mad_stream_errorstr: Option<unsafe extern "C" fn(_: *const mad_stream)
                                        -> *const libc::c_char>,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mad_stream {
    pub buffer: *const libc::c_uchar,
    pub bufend: *const libc::c_uchar,
    pub skiplen: libc::c_ulong,
    pub sync: libc::c_int,
    pub freerate: libc::c_ulong,
    pub this_frame: *const libc::c_uchar,
    pub next_frame: *const libc::c_uchar,
    pub ptr: mad_bitptr,
    pub anc_ptr: mad_bitptr,
    pub anc_bitlen: libc::c_uint,
    pub main_data: *mut [libc::c_uchar; 2567],
    pub md_len: libc::c_uint,
    pub options: libc::c_int,
    pub error: mad_error,
}
pub type mad_error = libc::c_uint;
pub const MAD_ERROR_BADSTEREO: mad_error = 569;
pub const MAD_ERROR_BADHUFFDATA: mad_error = 568;
pub const MAD_ERROR_BADHUFFTABLE: mad_error = 567;
pub const MAD_ERROR_BADPART3LEN: mad_error = 566;
pub const MAD_ERROR_BADDATAPTR: mad_error = 565;
pub const MAD_ERROR_BADSCFSI: mad_error = 564;
pub const MAD_ERROR_BADBLOCKTYPE: mad_error = 563;
pub const MAD_ERROR_BADBIGVALUES: mad_error = 562;
pub const MAD_ERROR_BADFRAMELEN: mad_error = 561;
pub const MAD_ERROR_BADMODE: mad_error = 546;
pub const MAD_ERROR_BADSCALEFACTOR: mad_error = 545;
pub const MAD_ERROR_BADBITALLOC: mad_error = 529;
pub const MAD_ERROR_BADCRC: mad_error = 513;
pub const MAD_ERROR_BADEMPHASIS: mad_error = 261;
pub const MAD_ERROR_BADSAMPLERATE: mad_error = 260;
pub const MAD_ERROR_BADBITRATE: mad_error = 259;
pub const MAD_ERROR_BADLAYER: mad_error = 258;
pub const MAD_ERROR_LOSTSYNC: mad_error = 257;
pub const MAD_ERROR_NOMEM: mad_error = 49;
pub const MAD_ERROR_BUFPTR: mad_error = 2;
pub const MAD_ERROR_BUFLEN: mad_error = 1;
pub const MAD_ERROR_NONE: mad_error = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mad_bitptr {
    pub byte: *const libc::c_uchar,
    pub cache: libc::c_ushort,
    pub left: libc::c_ushort,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mad_frame {
    pub header: mad_header,
    pub options: libc::c_int,
    pub sbsample: [[[mad_fixed_t; 32]; 36]; 2],
    pub overlap: *mut [[[mad_fixed_t; 18]; 32]; 2],
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mad_header {
    pub layer: mad_layer,
    pub mode: mad_mode,
    pub mode_extension: libc::c_int,
    pub emphasis: mad_emphasis,
    pub bitrate: libc::c_ulong,
    pub samplerate: libc::c_uint,
    pub crc_check: libc::c_ushort,
    pub crc_target: libc::c_ushort,
    pub flags: libc::c_int,
    pub private_bits: libc::c_int,
    pub duration: mad_timer_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mad_timer_t {
    pub seconds: libc::c_long,
    pub fraction: libc::c_ulong,
}
pub type mad_emphasis = libc::c_uint;
pub const MAD_EMPHASIS_RESERVED: mad_emphasis = 2;
pub const MAD_EMPHASIS_CCITT_J_17: mad_emphasis = 3;
pub const MAD_EMPHASIS_50_15_US: mad_emphasis = 1;
pub const MAD_EMPHASIS_NONE: mad_emphasis = 0;
pub type mad_mode = libc::c_uint;
pub const MAD_MODE_STEREO: mad_mode = 3;
pub const MAD_MODE_JOINT_STEREO: mad_mode = 2;
pub const MAD_MODE_DUAL_CHANNEL: mad_mode = 1;
pub const MAD_MODE_SINGLE_CHANNEL: mad_mode = 0;
pub type mad_layer = libc::c_uint;
pub const MAD_LAYER_III: mad_layer = 3;
pub const MAD_LAYER_II: mad_layer = 2;
pub const MAD_LAYER_I: mad_layer = 1;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mad_synth {
    pub filter: [[[[[mad_fixed_t; 8]; 16]; 2]; 2]; 2],
    pub phase: libc::c_uint,
    pub pcm: mad_pcm,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mad_pcm {
    pub samplerate: libc::c_uint,
    pub channels: libc::c_ushort,
    pub length: libc::c_ushort,
    pub samples: [[mad_fixed_t; 1152]; 2],
}
static mut m: *mut mad = 0 as *const mad as *mut mad;
// based on libmad minimad.c scale
#[inline]
unsafe extern "C" fn scale(mut sample: mad_fixed_t) -> u32_t {
    sample =
        (sample as libc::c_long +
             ((1 as libc::c_long) << 28 as libc::c_int - 24 as libc::c_int))
            as mad_fixed_t;
    if sample >= 0x10000000 as libc::c_long as mad_fixed_t {
        sample = 0x10000000 as libc::c_long as mad_fixed_t - 1 as libc::c_int
    } else if sample < -(0x10000000 as libc::c_long as mad_fixed_t) {
        sample = -(0x10000000 as libc::c_long as mad_fixed_t)
    }
    return ((sample >>
                 28 as libc::c_int + 1 as libc::c_int - 24 as libc::c_int) <<
                8 as libc::c_int) as u32_t;
}
// check for id3.2 tag at start of file - http://id3.org/id3v2.4.0-structure, return length
unsafe extern "C" fn _check_id3_tag(mut bytes: size_t) -> libc::c_uint {
    let mut ptr: *mut u8_t = (*streambuf).readp;
    let mut size: u32_t = 0 as libc::c_int as u32_t;
    if bytes > 10 as libc::c_int as libc::c_ulong &&
           *ptr as libc::c_int == 'I' as i32 &&
           *ptr.offset(1 as libc::c_int as isize) as libc::c_int == 'D' as i32
           &&
           *ptr.offset(2 as libc::c_int as isize) as libc::c_int == '3' as i32
       {
        // size is encoded as syncsafe integer, add 10 if footer present
        if (*ptr.offset(6 as libc::c_int as isize) as libc::c_int) <
               0x80 as libc::c_int &&
               (*ptr.offset(7 as libc::c_int as isize) as libc::c_int) <
                   0x80 as libc::c_int &&
               (*ptr.offset(8 as libc::c_int as isize) as libc::c_int) <
                   0x80 as libc::c_int &&
               (*ptr.offset(9 as libc::c_int as isize) as libc::c_int) <
                   0x80 as libc::c_int {
            size =
                (10 as libc::c_int +
                     ((*ptr.offset(6 as libc::c_int as isize) as libc::c_int)
                          << 21 as libc::c_int) +
                     ((*ptr.offset(7 as libc::c_int as isize) as libc::c_int)
                          << 14 as libc::c_int) +
                     ((*ptr.offset(8 as libc::c_int as isize) as libc::c_int)
                          << 7 as libc::c_int) +
                     *ptr.offset(9 as libc::c_int as isize) as libc::c_int +
                     (if *ptr.offset(5 as libc::c_int as isize) as libc::c_int
                             & 0x10 as libc::c_int != 0 {
                          10 as libc::c_int
                      } else { 0 as libc::c_int })) as u32_t;
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d id3.2 tag len: %u\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 15],
                                                   &[libc::c_char; 15]>(b"_check_id3_tag\x00")).as_ptr(),
                         111 as libc::c_int, size);
            }
        }
    }
    return size;
}
// check for lame gapless params, don't advance streambuf
unsafe extern "C" fn _check_lame_header(mut bytes: size_t) {
    let mut ptr: *mut u8_t = (*streambuf).readp;
    if *ptr as libc::c_int == 0xff as libc::c_int &&
           *ptr.offset(1 as libc::c_int as isize) as libc::c_int &
               0xf0 as libc::c_int == 0xf0 as libc::c_int &&
           bytes > 180 as libc::c_int as libc::c_ulong {
        let mut frame_count: u32_t = 0 as libc::c_int as u32_t;
        let mut enc_delay: u32_t = 0 as libc::c_int as u32_t;
        let mut enc_padding: u32_t = 0 as libc::c_int as u32_t;
        let mut flags: u8_t = 0;
        // 2 channels
        if memcmp(ptr.offset(36 as libc::c_int as isize) as
                      *const libc::c_void,
                  b"Xing\x00" as *const u8 as *const libc::c_char as
                      *const libc::c_void, 4 as libc::c_int as libc::c_ulong)
               == 0 ||
               memcmp(ptr.offset(36 as libc::c_int as isize) as
                          *const libc::c_void,
                      b"Info\x00" as *const u8 as *const libc::c_char as
                          *const libc::c_void,
                      4 as libc::c_int as libc::c_ulong) == 0 {
            ptr = ptr.offset((36 as libc::c_int + 7 as libc::c_int) as isize)
            // mono	
        } else if memcmp(ptr.offset(21 as libc::c_int as isize) as
                             *const libc::c_void,
                         b"Xing\x00" as *const u8 as *const libc::c_char as
                             *const libc::c_void,
                         4 as libc::c_int as libc::c_ulong) == 0 ||
                      memcmp(ptr.offset(21 as libc::c_int as isize) as
                                 *const libc::c_void,
                             b"Info\x00" as *const u8 as *const libc::c_char
                                 as *const libc::c_void,
                             4 as libc::c_int as libc::c_ulong) == 0 {
            ptr = ptr.offset((21 as libc::c_int + 7 as libc::c_int) as isize)
        }
        flags = *ptr;
        if flags as libc::c_int & 0x1 as libc::c_int != 0 {
            frame_count =
                unpackN(ptr.offset(1 as libc::c_int as isize) as *mut u32_t);
            ptr = ptr.offset(4 as libc::c_int as isize)
        }
        if flags as libc::c_int & 0x2 as libc::c_int != 0 {
            ptr = ptr.offset(4 as libc::c_int as isize)
        }
        if flags as libc::c_int & 0x4 as libc::c_int != 0 {
            ptr = ptr.offset(100 as libc::c_int as isize)
        }
        if flags as libc::c_int & 0x8 as libc::c_int != 0 {
            ptr = ptr.offset(4 as libc::c_int as isize)
        }
        if memcmp(ptr.offset(1 as libc::c_int as isize) as
                      *const libc::c_void,
                  b"LAME\x00" as *const u8 as *const libc::c_char as
                      *const libc::c_void, 4 as libc::c_int as libc::c_ulong)
               != 0 {
            return
        }
        ptr = ptr.offset(22 as libc::c_int as isize);
        enc_delay =
            (((*ptr as libc::c_int) << 4 as libc::c_int |
                  *ptr.offset(1 as libc::c_int as isize) as libc::c_int >>
                      4 as libc::c_int) + 529 as libc::c_int) as u32_t;
        enc_padding =
            ((*ptr.offset(1 as libc::c_int as isize) as libc::c_int &
                  0xf as libc::c_int) << 8 as libc::c_int |
                 *ptr.offset(2 as libc::c_int as isize) as libc::c_int) as
                u32_t;
        enc_padding =
            if enc_padding > 529 as libc::c_int as libc::c_uint {
                enc_padding.wrapping_sub(529 as libc::c_int as libc::c_uint)
            } else { 0 as libc::c_int as libc::c_uint };
        // add one frame to initial skip for this (empty) frame
        (*m).skip =
            enc_delay.wrapping_add(1152 as libc::c_int as libc::c_uint);
        (*m).samples =
            frame_count.wrapping_mul(1152 as libc::c_int as
                                         libc::c_uint).wrapping_sub(enc_delay).wrapping_sub(enc_padding)
                as u64_t;
        (*m).padding = enc_padding;
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d gapless: skip: %u samples: %lu delay: %u padding: %u\n\x00"
                         as *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 19],
                                               &[libc::c_char; 19]>(b"_check_lame_header\x00")).as_ptr(),
                     160 as libc::c_int, (*m).skip, (*m).samples, enc_delay,
                     enc_padding);
        }
    };
}
unsafe extern "C" fn mad_decode() -> decode_state {
    let mut bytes: size_t = 0;
    let mut eos: bool = 0 as libc::c_int != 0;
    pthread_mutex_lock(&mut (*streambuf).mutex);
    bytes =
        if _buf_used(streambuf) < _buf_cont_read(streambuf) {
            _buf_used(streambuf)
        } else { _buf_cont_read(streambuf) } as size_t;
    if (*m).checktags != 0 {
        if (*m).checktags == 1 as libc::c_int {
            (*m).consume = _check_id3_tag(bytes);
            (*m).checktags = 2 as libc::c_int
        }
        if (*m).consume != 0 {
            let mut consume: u32_t =
                if ((*m).consume as libc::c_ulong) < bytes {
                    (*m).consume as libc::c_ulong
                } else { bytes } as u32_t;
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d consume: %u of %u\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 11],
                                                   &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                         178 as libc::c_int, consume, (*m).consume);
            }
            _buf_inc_readp(streambuf, consume);
            (*m).consume =
                ((*m).consume as libc::c_uint).wrapping_sub(consume) as u32_t
                    as u32_t;
            pthread_mutex_unlock(&mut (*streambuf).mutex);
            return DECODE_RUNNING
        }
        if (*m).checktags == 2 as libc::c_int {
            if stream.meta_interval == 0 { _check_lame_header(bytes); }
            (*m).checktags = 0 as libc::c_int
        }
    }
    if !(*m).stream.next_frame.is_null() && (*m).readbuf_len != 0 {
        (*m).readbuf_len =
            ((*m).readbuf_len as libc::c_long -
                 (*m).stream.next_frame.wrapping_offset_from((*m).readbuf) as
                     libc::c_long) as libc::c_uint;
        memmove((*m).readbuf as *mut libc::c_void,
                (*m).stream.next_frame as *const libc::c_void,
                (*m).readbuf_len as libc::c_ulong);
    }
    bytes =
        if bytes <
               (2048 as libc::c_int as
                    libc::c_uint).wrapping_sub((*m).readbuf_len) as
                   libc::c_ulong {
            bytes
        } else {
            (2048 as libc::c_int as
                 libc::c_uint).wrapping_sub((*m).readbuf_len) as libc::c_ulong
        };
    memcpy((*m).readbuf.offset((*m).readbuf_len as isize) as
               *mut libc::c_void, (*streambuf).readp as *const libc::c_void,
           bytes);
    (*m).readbuf_len =
        ((*m).readbuf_len as libc::c_ulong).wrapping_add(bytes) as
            libc::c_uint as libc::c_uint;
    _buf_inc_readp(streambuf, bytes as libc::c_uint);
    if stream.state as libc::c_uint <=
           DISCONNECT as libc::c_int as libc::c_uint &&
           _buf_used(streambuf) == 0 as libc::c_int as libc::c_uint {
        eos = 1 as libc::c_int != 0;
        if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d end of stream\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                     204 as libc::c_int);
        }
        memset((*m).readbuf.offset((*m).readbuf_len as isize) as
                   *mut libc::c_void, 0 as libc::c_int,
               8 as libc::c_int as libc::c_ulong);
        (*m).readbuf_len =
            (*m).readbuf_len.wrapping_add(8 as libc::c_int as libc::c_uint)
    }
    pthread_mutex_unlock(&mut (*streambuf).mutex);
    (*m).mad_stream_buffer.expect("non-null function pointer")(&mut (*m).stream,
                                                               (*m).readbuf,
                                                               (*m).readbuf_len
                                                                   as
                                                                   libc::c_ulong);
    loop  {
        let mut frames: size_t = 0;
        let mut iptrl: *mut s32_t = 0 as *mut s32_t;
        let mut iptrr: *mut s32_t = 0 as *mut s32_t;
        let mut max_frames: libc::c_uint = 0;
        if (*m).mad_frame_decode.expect("non-null function pointer")(&mut (*m).frame,
                                                                     &mut (*m).stream)
               == -(1 as libc::c_int) {
            let mut ret: decode_state = DECODE_STOPPED;
            if !eos &&
                   (*m).stream.error as libc::c_uint ==
                       MAD_ERROR_BUFLEN as libc::c_int as libc::c_uint {
                ret = DECODE_RUNNING
            } else if eos as libc::c_int != 0 &&
                          ((*m).stream.error as libc::c_uint ==
                               MAD_ERROR_BUFLEN as libc::c_int as libc::c_uint
                               ||
                               (*m).stream.error as libc::c_uint ==
                                   MAD_ERROR_LOSTSYNC as libc::c_int as
                                       libc::c_uint ||
                               (*m).stream.error as libc::c_uint ==
                                   MAD_ERROR_BADBITRATE as libc::c_int as
                                       libc::c_uint) {
                ret = DECODE_COMPLETE
            } else if (*m).stream.error as libc::c_uint &
                          0xff00 as libc::c_int as libc::c_uint == 0 {
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d mad_frame_decode error: %s - stopping decoder\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 11],
                                                       &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                             227 as libc::c_int,
                             (*m).mad_stream_errorstr.expect("non-null function pointer")(&mut (*m).stream));
                }
                ret = DECODE_COMPLETE
            } else {
                if (*m).stream.error as libc::c_uint !=
                       (*m).last_error as libc::c_uint {
                    // suppress repeat error messages
                    if loglevel as libc::c_uint >=
                           lDEBUG as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d mad_frame_decode error: %s\n\x00"
                                     as *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 11],
                                                           &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                                 232 as libc::c_int,
                                 (*m).mad_stream_errorstr.expect("non-null function pointer")(&mut (*m).stream));
                    }
                }
                ret = DECODE_RUNNING
            }
            (*m).last_error = (*m).stream.error;
            return ret
        }
        (*m).mad_synth_frame.expect("non-null function pointer")(&mut (*m).synth,
                                                                 &mut (*m).frame);
        if decode.new_stream {
            pthread_mutex_lock(&mut (*outputbuf).mutex);
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d setting track_start\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 11],
                                                   &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                         244 as libc::c_int);
            }
            output.next_sample_rate =
                decode_newstream((*m).synth.pcm.samplerate,
                                 output.supported_rates.as_mut_ptr());
            output.track_start = (*outputbuf).writep;
            if output.fade_mode as u64 != 0 {
                _checkfade(1 as libc::c_int != 0);
            }
            decode.new_stream = 0 as libc::c_int != 0;
            pthread_mutex_unlock(&mut (*outputbuf).mutex);
        }
        pthread_mutex_lock(&mut (*outputbuf).mutex);
        max_frames =
            _buf_space(outputbuf).wrapping_div(8 as libc::c_int as
                                                   libc::c_uint);
        if (*m).synth.pcm.length as libc::c_uint > max_frames {
            if loglevel as libc::c_uint >=
                   lWARN as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d too many samples - dropping samples\n\x00"
                             as *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 11],
                                                   &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                         263 as libc::c_int);
            }
            (*m).synth.pcm.length = max_frames as libc::c_ushort
        }
        frames = (*m).synth.pcm.length as size_t;
        iptrl =
            (*m).synth.pcm.samples[0 as libc::c_int as usize].as_mut_ptr();
        iptrr =
            (*m).synth.pcm.samples[((*m).synth.pcm.channels as libc::c_int -
                                        1 as libc::c_int) as
                                       usize].as_mut_ptr();
        if (*m).skip != 0 {
            let mut skip: u32_t =
                if ((*m).skip as libc::c_ulong) < frames {
                    (*m).skip as libc::c_ulong
                } else { frames } as u32_t;
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d gapless: skipping %u frames at start\n\x00"
                             as *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 11],
                                                   &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                         273 as libc::c_int, skip);
            }
            frames =
                (frames as libc::c_ulong).wrapping_sub(skip as libc::c_ulong)
                    as size_t as size_t;
            (*m).skip =
                ((*m).skip as libc::c_uint).wrapping_sub(skip) as u32_t as
                    u32_t;
            iptrl = iptrl.offset(skip as isize);
            iptrr = iptrr.offset(skip as isize)
        }
        if (*m).samples != 0 {
            if (*m).samples < frames {
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d gapless: trimming %u frames from end\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 11],
                                                       &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                             282 as libc::c_int,
                             frames.wrapping_sub((*m).samples));
                }
                frames = (*m).samples
            }
            (*m).samples =
                ((*m).samples as libc::c_ulong).wrapping_sub(frames) as u64_t
                    as u64_t;
            if (*m).samples > 0 as libc::c_int as libc::c_ulong &&
                   eos as libc::c_int != 0 &&
                   !(*(*m).stream.next_frame.offset(0 as libc::c_int as isize)
                         as libc::c_int == 0xff as libc::c_int &&
                         *(*m).stream.next_frame.offset(1 as libc::c_int as
                                                            isize) as
                             libc::c_int & 0xf0 as libc::c_int ==
                             0xf0 as libc::c_int) {
                // this is the last frame to be decoded, but more samples expected so we must have skipped, remove padding
				// note this only works if the padding is less than one frame of 1152 bytes otherswise some gap will remain
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d gapless: early end - trimming padding from end\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 11],
                                                       &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                             289 as libc::c_int);
                }
                if frames >= (*m).padding as libc::c_ulong {
                    frames =
                        (frames as
                             libc::c_ulong).wrapping_sub((*m).padding as
                                                             libc::c_ulong) as
                            size_t as size_t
                } else { frames = 0 as libc::c_int as size_t }
                (*m).samples = 0 as libc::c_int as u64_t
            }
        }
        if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint
           {
            logprint(b"%s %s:%d write %u frames\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"mad_decode\x00")).as_ptr(),
                     299 as libc::c_int, frames);
        }
        while frames > 0 as libc::c_int as libc::c_ulong {
            let mut f: size_t = 0;
            let mut count: size_t = 0;
            let mut optr: *mut s32_t = 0 as *mut s32_t;
            f =
                if frames <
                       _buf_cont_write(outputbuf).wrapping_div(8 as
                                                                   libc::c_int
                                                                   as
                                                                   libc::c_uint)
                           as libc::c_ulong {
                    frames
                } else {
                    _buf_cont_write(outputbuf).wrapping_div(8 as libc::c_int
                                                                as
                                                                libc::c_uint)
                        as libc::c_ulong
                };
            optr = (*outputbuf).writep as *mut s32_t;
            count = f;
            loop  {
                let fresh0 = count;
                count = count.wrapping_sub(1);
                if !(fresh0 != 0) { break ; }
                let fresh1 = iptrl;
                iptrl = iptrl.offset(1);
                let fresh2 = optr;
                optr = optr.offset(1);
                *fresh2 = scale(*fresh1) as s32_t;
                let fresh3 = iptrr;
                iptrr = iptrr.offset(1);
                let fresh4 = optr;
                optr = optr.offset(1);
                *fresh4 = scale(*fresh3) as s32_t
            }
            frames =
                (frames as libc::c_ulong).wrapping_sub(f) as size_t as size_t;
            _buf_inc_writep(outputbuf,
                            f.wrapping_mul(8 as libc::c_int as libc::c_ulong)
                                as libc::c_uint);
        }
        pthread_mutex_unlock(&mut (*outputbuf).mutex);
    };
}
unsafe extern "C" fn mad_open(mut size: u8_t, mut rate: u8_t, mut chan: u8_t,
                              mut endianness: u8_t) {
    if (*m).readbuf.is_null() {
        (*m).readbuf =
            malloc((2048 as libc::c_int + 8 as libc::c_int) as libc::c_ulong)
                as *mut u8_t
    }
    (*m).checktags = 1 as libc::c_int;
    (*m).consume = 0 as libc::c_int as u32_t;
    (*m).skip = 529 as libc::c_int as u32_t;
    (*m).samples = 0 as libc::c_int as u64_t;
    (*m).readbuf_len = 0 as libc::c_int as libc::c_uint;
    (*m).last_error = MAD_ERROR_NONE;
    (*m).mad_stream_init.expect("non-null function pointer")(&mut (*m).stream);
    (*m).mad_frame_init.expect("non-null function pointer")(&mut (*m).frame);
    (*m).mad_synth_init.expect("non-null function pointer")(&mut (*m).synth);
}
unsafe extern "C" fn mad_close() {
    // macro only in current version
    (*m).mad_frame_finish.expect("non-null function pointer")(&mut (*m).frame);
    (*m).mad_stream_finish.expect("non-null function pointer")(&mut (*m).stream);
    free((*m).readbuf as *mut libc::c_void);
    (*m).readbuf = 0 as *mut u8_t;
}
unsafe extern "C" fn load_mad() -> bool {
    let mut handle: *mut libc::c_void =
        dlopen(b"libmad.so.0\x00" as *const u8 as *const libc::c_char,
               0x2 as libc::c_int);
    let mut err: *mut libc::c_char = 0 as *mut libc::c_char;
    if handle.is_null() {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d dlerror: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"load_mad\x00")).as_ptr(),
                     366 as libc::c_int, dlerror());
        }
        return 0 as libc::c_int != 0
    }
    (*m).mad_stream_init =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mad_stream)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mad_stream_init\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mad_frame_init =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: *mut mad_frame)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mad_frame_init\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mad_synth_init =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: *mut mad_synth)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mad_synth_init\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mad_frame_finish =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: *mut mad_frame)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mad_frame_finish\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mad_stream_finish =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mad_stream)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mad_stream_finish\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mad_stream_buffer =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mad_stream,
                                                            _:
                                                                *const libc::c_uchar,
                                                            _: libc::c_ulong)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mad_stream_buffer\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mad_frame_decode =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: *mut mad_frame,
                                                            _:
                                                                *mut mad_stream)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"mad_frame_decode\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*m).mad_synth_frame =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: *mut mad_synth,
                                                            _:
                                                                *const mad_frame)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mad_synth_frame\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mad_stream_errorstr =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *const mad_stream)
                                           ->
                                               *const libc::c_char>>(dlsym(handle,
                                                                           b"mad_stream_errorstr\x00"
                                                                               as
                                                                               *const u8
                                                                               as
                                                                               *const libc::c_char));
    err = dlerror();
    if !err.is_null() {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d dlerror: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"load_mad\x00")).as_ptr(),
                     381 as libc::c_int, err);
        }
        return 0 as libc::c_int != 0
    }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d loaded libmad.so.0\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"load_mad\x00")).as_ptr(),
                 385 as libc::c_int);
    }
    return 1 as libc::c_int != 0;
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
// output_pack.c
// output_vis.c
// dop.c
// codecs
#[no_mangle]
pub unsafe extern "C" fn register_mad() -> *mut codec {
    static mut ret: codec =
        unsafe {
            {
                let mut init =
                    codec{id: 'm' as i32 as libc::c_char,
                          types:
                              b"mp3\x00" as *const u8 as *const libc::c_char
                                  as *mut libc::c_char,
                          min_read_bytes: 2048 as libc::c_int as libc::c_uint,
                          min_space: 206800 as libc::c_int as libc::c_uint,
                          open:
                              Some(mad_open as
                                       unsafe extern "C" fn(_: u8_t, _: u8_t,
                                                            _: u8_t, _: u8_t)
                                           -> ()),
                          close:
                              Some(mad_close as unsafe extern "C" fn() -> ()),
                          decode:
                              Some(mad_decode as
                                       unsafe extern "C" fn()
                                           -> decode_state),};
                init
            }
        };
    m = malloc(::std::mem::size_of::<mad>() as libc::c_ulong) as *mut mad;
    if m.is_null() { return 0 as *mut codec }
    (*m).readbuf = 0 as *mut u8_t;
    (*m).readbuf_len = 0 as libc::c_int as libc::c_uint;
    if !load_mad() { return 0 as *mut codec }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d using mad to decode mp3\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"register_mad\x00")).as_ptr(),
                 414 as libc::c_int);
    }
    return &mut ret;
}
