use ::libc;
extern "C" {
    pub type _IO_wide_data;
    pub type _IO_codecvt;
    pub type _IO_marker;
    #[no_mangle]
    fn getpid() -> __pid_t;
    /* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
    // make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
    // build detection
    // dynamically loaded libraries at run time
    // !LINKALL
    // config options
    // do not reduce as icy-meta max is 4080
    /* SUN */
    /* SUN */
    // printf/scanf formats for u64_t
    // logging
    // utils.c (non logging)
    // buffer.c
    // _* called with mutex locked
    // slimproto.c
    // stream.c
    // decode.c
    // output.c output_alsa.c output_pa.c output_pack.c
    // frames played at the point delay is measured
    // ordered largest first so [0] is max_rate
    // set in decode thread
    // set in decode thread
    // set by slimproto
    // set by slimproto
    // set by slimproto
    // set by slimproto
    // set by slimproto
    // set by slimproto
    // set by slimproto
    // _* called with mutex locked
    // output_alsa.c
    // output_pa.c
    // output_pulse.c
    // output_stdout.c
    #[no_mangle]
    fn output_close_stdout();
    #[no_mangle]
    static mut stderr: *mut FILE;
    #[no_mangle]
    fn fclose(__stream: *mut FILE) -> libc::c_int;
    #[no_mangle]
    fn fopen(_: *const libc::c_char, _: *const libc::c_char) -> *mut FILE;
    #[no_mangle]
    fn freopen(__filename: *const libc::c_char, __modes: *const libc::c_char,
               __stream: *mut FILE) -> *mut FILE;
    #[no_mangle]
    fn fprintf(_: *mut FILE, _: *const libc::c_char, _: ...) -> libc::c_int;
    #[no_mangle]
    fn printf(_: *const libc::c_char, _: ...) -> libc::c_int;
    #[no_mangle]
    fn atoi(__nptr: *const libc::c_char) -> libc::c_int;
    #[no_mangle]
    fn strtoul(_: *const libc::c_char, _: *mut *mut libc::c_char,
               _: libc::c_int) -> libc::c_ulong;
    #[no_mangle]
    fn free(__ptr: *mut libc::c_void);
    #[no_mangle]
    fn exit(_: libc::c_int) -> !;
    #[no_mangle]
    fn realpath(__name: *const libc::c_char, __resolved: *mut libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strcat(_: *mut libc::c_char, _: *const libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strcmp(_: *const libc::c_char, _: *const libc::c_char) -> libc::c_int;
    #[no_mangle]
    fn strncmp(_: *const libc::c_char, _: *const libc::c_char,
               _: libc::c_ulong) -> libc::c_int;
    #[no_mangle]
    fn strstr(_: *const libc::c_char, _: *const libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strtok(_: *mut libc::c_char, _: *const libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strlen(_: *const libc::c_char) -> libc::c_ulong;
    #[no_mangle]
    fn strerror(_: libc::c_int) -> *mut libc::c_char;
    #[no_mangle]
    fn __errno_location() -> *mut libc::c_int;
    #[no_mangle]
    fn unlink(__name: *const libc::c_char) -> libc::c_int;
    #[no_mangle]
    fn daemon(__nochdir: libc::c_int, __noclose: libc::c_int) -> libc::c_int;
    #[no_mangle]
    fn signal(__sig: libc::c_int, __handler: __sighandler_t)
     -> __sighandler_t;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn next_param(src: *mut libc::c_char, c: libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn get_mac(mac: *mut u8_t);
    #[no_mangle]
    fn slimproto(level: log_level, server: *mut libc::c_char, mac: *mut u8_t,
                 name: *const libc::c_char, namefile: *const libc::c_char,
                 modelname: *const libc::c_char, maxSampleRate: libc::c_int);
    #[no_mangle]
    fn slimproto_stop();
    #[no_mangle]
    fn stream_init(level: log_level, stream_buf_size: libc::c_uint);
    #[no_mangle]
    fn stream_close();
    #[no_mangle]
    fn decode_init(level: log_level, include_codecs: *const libc::c_char,
                   exclude_codecs: *const libc::c_char);
    #[no_mangle]
    fn decode_close();
    #[no_mangle]
    fn list_devices();
    #[no_mangle]
    fn list_mixers(output_device: *const libc::c_char);
    #[no_mangle]
    fn output_init_alsa(level: log_level, device: *const libc::c_char,
                        output_buf_size: libc::c_uint,
                        params: *mut libc::c_char, rates: *mut libc::c_uint,
                        rate_delay: libc::c_uint, rt_priority: libc::c_uint,
                        idle: libc::c_uint, mixer_device: *mut libc::c_char,
                        volume_mixer: *mut libc::c_char, mixer_unmute: bool,
                        mixer_linear: bool);
    #[no_mangle]
    fn output_close_alsa();
    #[no_mangle]
    fn output_init_stdout(level: log_level, output_buf_size: libc::c_uint,
                          params: *mut libc::c_char, rates: *mut libc::c_uint,
                          rate_delay: libc::c_uint);
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __off_t = libc::c_long;
pub type __off64_t = libc::c_long;
pub type __pid_t = libc::c_int;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct _IO_FILE {
    pub _flags: libc::c_int,
    pub _IO_read_ptr: *mut libc::c_char,
    pub _IO_read_end: *mut libc::c_char,
    pub _IO_read_base: *mut libc::c_char,
    pub _IO_write_base: *mut libc::c_char,
    pub _IO_write_ptr: *mut libc::c_char,
    pub _IO_write_end: *mut libc::c_char,
    pub _IO_buf_base: *mut libc::c_char,
    pub _IO_buf_end: *mut libc::c_char,
    pub _IO_save_base: *mut libc::c_char,
    pub _IO_backup_base: *mut libc::c_char,
    pub _IO_save_end: *mut libc::c_char,
    pub _markers: *mut _IO_marker,
    pub _chain: *mut _IO_FILE,
    pub _fileno: libc::c_int,
    pub _flags2: libc::c_int,
    pub _old_offset: __off_t,
    pub _cur_column: libc::c_ushort,
    pub _vtable_offset: libc::c_schar,
    pub _shortbuf: [libc::c_char; 1],
    pub _lock: *mut libc::c_void,
    pub _offset: __off64_t,
    pub _codecvt: *mut _IO_codecvt,
    pub _wide_data: *mut _IO_wide_data,
    pub _freeres_list: *mut _IO_FILE,
    pub _freeres_buf: *mut libc::c_void,
    pub __pad5: size_t,
    pub _mode: libc::c_int,
    pub _unused2: [libc::c_char; 20],
}
pub type _IO_lock_t = ();
pub type FILE = _IO_FILE;
pub type u_int8_t = __uint8_t;
pub type __sighandler_t = Option<unsafe extern "C" fn(_: libc::c_int) -> ()>;
pub type u8_t = u_int8_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2020, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
unsafe extern "C" fn usage(mut argv0: *const libc::c_char) {
    printf(b"Squeezelite v1.9.7-1223, Copyright 2012-2015 Adrian Smith, 2015-2020 Ralph Irving. See -t for license terms\nUsage: %s [options]\n  -s <server>[:<port>]\tConnect to specified server, otherwise uses autodiscovery to find server\n  -o <output device>\tSpecify output device, default \"default\", - = output to stdout\n  -l \t\t\tList output devices\n  -a <b>:<p>:<f>:<m>\tSpecify ALSA params to open output device, b = buffer time in ms or size in bytes, p = period count or size in bytes, f sample format (16|24|24_3|32), m = use mmap (0|1)\n  -a <f>\t\tSpecify sample format (16|24|32) of output file when using -o - to output samples to stdout (interleaved little endian only)\n  -b <stream>:<output>\tSpecify internal Stream and Output buffer sizes in Kbytes\n  -c <codec1>,<codec2>\tRestrict codecs to those specified, otherwise load all available codecs; known codecs: flac,pcm,mp3,ogg,aac (mad,mpg for specific mp3 codec)\n  \t\t\tCodecs reported to LMS in order listed, allowing codec priority refinement.\n  -C <timeout>\t\tClose output device when idle after timeout seconds, default is to keep it open while player is \'on\'\n  -d <log>=<level>\tSet logging level, logs: all|slimproto|stream|decode|output, level: info|debug|sdebug\n  -e <codec1>,<codec2>\tExplicitly exclude native support of one or more codecs; known codecs: flac,pcm,mp3,ogg,aac (mad,mpg for specific mp3 codec)\n  -f <logfile>\t\tWrite debug to logfile\n  -m <mac addr>\t\tSet mac address, format: ab:cd:ef:12:34:56\n  -M <modelname>\tSet the squeezelite player model name sent to the server (default: SqueezeLite)\n  -n <name>\t\tSet the player name\n  -N <filename>\t\tStore player name in filename to allow server defined name changes to be shared between servers (not supported with -n)\n  -W\t\t\tRead wave and aiff format from header, ignore server parameters\n  -p <priority>\t\tSet real time priority of output thread (1-99)\n  -P <filename>\t\tStore the process id (PID) in filename\n  -r <rates>[:<delay>]\tSample rates supported, allows output to be off when squeezelite is started; rates = <maxrate>|<minrate>-<maxrate>|<rate1>,<rate2>,<rate3>; delay = optional delay switching rates in ms\n  -O <mixer device>\tSpecify mixer device, defaults to \'output device\'\n  -L \t\t\tList volume controls for output device\n  -U <control>\t\tUnmute ALSA control and set to full volume (not supported with -V)\n  -V <control>\t\tUse ALSA control for volume adjustment, otherwise use software volume adjustment\n  -X \t\t\tUse linear volume adjustments instead of in terms of dB (only for hardware volume control)\n  -z \t\t\tDaemonize\n  -t \t\t\tLicense terms\n  -? \t\t\tDisplay this help text\n\nBuild options: LINUX ALSA EVENTFD\n\n\x00"
               as *const u8 as *const libc::c_char, argv0);
}
unsafe extern "C" fn license() {
    printf(b"Squeezelite v1.9.7-1223, Copyright 2012-2015 Adrian Smith, 2015-2020 Ralph Irving.\n\nThis program is free software: you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published by\nthe Free Software Foundation, either version 3 of the License, or\n(at your option) any later version.\n\nThis program is distributed in the hope that it will be useful,\nbut WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\nGNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License\nalong with this program.  If not, see <http://www.gnu.org/licenses/>.\n\nOption to allow server side upsampling for PCM streams (-W) from\nsqueezelite-R2 (c) Marco Curti 2015, marcoc1712@gmail.com.\n\n\x00"
               as *const u8 as *const libc::c_char);
}
unsafe extern "C" fn sighandler(mut signum: libc::c_int) {
    slimproto_stop();
    // remove ourselves in case above does not work, second SIGINT will cause non gracefull shutdown
    signal(signum, None); // set later
}
#[cross_check(entry(djb2="main"), exit(djb2="main"))]
unsafe fn main_0(mut argc: libc::c_int, mut argv: *mut *mut libc::c_char)
 -> libc::c_int {
    let mut server: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut output_device: *mut libc::c_char =
        b"default\x00" as *const u8 as *const libc::c_char as
            *mut libc::c_char;
    let mut include_codecs: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut exclude_codecs: *mut libc::c_char =
        b"\x00" as *const u8 as *const libc::c_char as *mut libc::c_char;
    let mut name: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut namefile: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut modelname: *mut libc::c_char = 0 as *mut libc::c_char;
    extern "C" {
        #[no_mangle]
        static mut pcm_check_header: bool;
    }
    extern "C" {
        #[no_mangle]
        static mut user_rates: bool;
    }
    let mut logfile: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut mac: [u8_t; 6] = [0; 6];
    let mut stream_buf_size: libc::c_uint =
        (2 as libc::c_int * 1024 as libc::c_int * 1024 as libc::c_int) as
            libc::c_uint;
    let mut output_buf_size: libc::c_uint = 0 as libc::c_int as libc::c_uint;
    let mut rates: [libc::c_uint; 18] =
        [0 as libc::c_int as libc::c_uint, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
         0, 0, 0, 0, 0];
    let mut rate_delay: libc::c_uint = 0 as libc::c_int as libc::c_uint;
    let mut resample: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut output_params: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut idle: libc::c_uint = 0 as libc::c_int as libc::c_uint;
    let mut daemonize: bool = 0 as libc::c_int != 0;
    let mut pidfile: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut pidfp: *mut FILE = 0 as *mut FILE;
    let mut rt_priority: libc::c_uint = 45 as libc::c_int as libc::c_uint;
    let mut mixer_device: *mut libc::c_char = output_device;
    let mut output_mixer: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut output_mixer_unmute: bool = 0 as libc::c_int != 0;
    let mut linear_volume: bool = 0 as libc::c_int != 0;
    let mut log_output: log_level = lWARN;
    let mut log_stream: log_level = lWARN;
    let mut log_decode: log_level = lWARN;
    let mut log_slimproto: log_level = lWARN;
    let mut maxSampleRate: libc::c_int = 0 as libc::c_int;
    let mut optarg: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut optind: libc::c_int = 1 as libc::c_int;
    let mut i: libc::c_int = 0;
    let mut cmdline: [libc::c_char; 512] =
        *::std::mem::transmute::<&[u8; 512],
                                 &mut [libc::c_char; 512]>(b"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00");
    get_mac(mac.as_mut_ptr());
    i = 0 as libc::c_int;
    while i < argc &&
              strlen(*argv.offset(i as
                                      isize)).wrapping_add(strlen(cmdline.as_mut_ptr())).wrapping_add(2
                                                                                                          as
                                                                                                          libc::c_int
                                                                                                          as
                                                                                                          libc::c_ulong)
                  < 512 as libc::c_int as libc::c_ulong {
        strcat(cmdline.as_mut_ptr(), *argv.offset(i as isize));
        strcat(cmdline.as_mut_ptr(),
               b" \x00" as *const u8 as *const libc::c_char);
        i += 1
    }
    while optind < argc &&
              strlen(*argv.offset(optind as isize)) >=
                  2 as libc::c_int as libc::c_ulong &&
              *(*argv.offset(optind as
                                 isize)).offset(0 as libc::c_int as isize) as
                  libc::c_int == '-' as i32 {
        let mut opt: *mut libc::c_char =
            (*argv.offset(optind as isize)).offset(1 as libc::c_int as isize);
        if !strstr(b"oabcCdefmMnNpPrsUVO\x00" as *const u8 as
                       *const libc::c_char, opt).is_null() &&
               optind < argc - 1 as libc::c_int {
            optarg = *argv.offset((optind + 1 as libc::c_int) as isize);
            optind += 2 as libc::c_int
        } else if !strstr(b"ltz?WLX\x00" as *const u8 as *const libc::c_char,
                          opt).is_null() {
            optarg = 0 as *mut libc::c_char;
            optind += 1 as libc::c_int
        } else {
            fprintf(stderr,
                    b"\nOption error: -%s\n\n\x00" as *const u8 as
                        *const libc::c_char, opt);
            usage(*argv.offset(0 as libc::c_int as isize));
            exit(1 as libc::c_int);
        }
        let mut current_block_129: u64;
        match *opt.offset(0 as libc::c_int as isize) as libc::c_int {
            111 => {
                output_device = optarg;
                mixer_device = optarg;
                current_block_129 = 10517665100358322178;
            }
            97 => {
                output_params = optarg;
                current_block_129 = 10517665100358322178;
            }
            98 => {
                let mut s: *mut libc::c_char =
                    next_param(optarg, ':' as i32 as libc::c_char);
                let mut o: *mut libc::c_char =
                    next_param(0 as *mut libc::c_char,
                               ':' as i32 as libc::c_char);
                if !s.is_null() {
                    stream_buf_size =
                        (atoi(s) * 1024 as libc::c_int) as libc::c_uint
                }
                if !o.is_null() {
                    output_buf_size =
                        (atoi(o) * 1024 as libc::c_int) as libc::c_uint
                }
                current_block_129 = 10517665100358322178;
            }
            99 => {
                include_codecs = optarg;
                current_block_129 = 10517665100358322178;
            }
            67 => {
                if atoi(optarg) > 0 as libc::c_int {
                    idle =
                        (atoi(optarg) * 1000 as libc::c_int) as libc::c_uint
                }
                current_block_129 = 10517665100358322178;
            }
            101 => {
                exclude_codecs = optarg;
                current_block_129 = 10517665100358322178;
            }
            100 => {
                let mut l: *mut libc::c_char =
                    strtok(optarg,
                           b"=\x00" as *const u8 as *const libc::c_char);
                let mut v: *mut libc::c_char =
                    strtok(0 as *mut libc::c_char,
                           b"=\x00" as *const u8 as *const libc::c_char);
                let mut new: log_level = lWARN;
                if !l.is_null() && !v.is_null() {
                    if strcmp(v,
                              b"info\x00" as *const u8 as *const libc::c_char)
                           == 0 {
                        new = lINFO
                    }
                    if strcmp(v,
                              b"debug\x00" as *const u8 as
                                  *const libc::c_char) == 0 {
                        new = lDEBUG
                    }
                    if strcmp(v,
                              b"sdebug\x00" as *const u8 as
                                  *const libc::c_char) == 0 {
                        new = lSDEBUG
                    }
                    if strcmp(l,
                              b"all\x00" as *const u8 as *const libc::c_char)
                           == 0 ||
                           strcmp(l,
                                  b"slimproto\x00" as *const u8 as
                                      *const libc::c_char) == 0 {
                        log_slimproto = new
                    }
                    if strcmp(l,
                              b"all\x00" as *const u8 as *const libc::c_char)
                           == 0 ||
                           strcmp(l,
                                  b"stream\x00" as *const u8 as
                                      *const libc::c_char) == 0 {
                        log_stream = new
                    }
                    if strcmp(l,
                              b"all\x00" as *const u8 as *const libc::c_char)
                           == 0 ||
                           strcmp(l,
                                  b"decode\x00" as *const u8 as
                                      *const libc::c_char) == 0 {
                        log_decode = new
                    }
                    if strcmp(l,
                              b"all\x00" as *const u8 as *const libc::c_char)
                           == 0 ||
                           strcmp(l,
                                  b"output\x00" as *const u8 as
                                      *const libc::c_char) == 0 {
                        log_output = new
                    }
                } else {
                    fprintf(stderr,
                            b"\nDebug settings error: -d %s\n\n\x00" as
                                *const u8 as *const libc::c_char, optarg);
                    usage(*argv.offset(0 as libc::c_int as isize));
                    exit(1 as libc::c_int);
                }
                current_block_129 = 10517665100358322178;
            }
            102 => {
                logfile = optarg;
                current_block_129 = 10517665100358322178;
            }
            109 => {
                let mut byte: libc::c_int = 0 as libc::c_int;
                let mut tmp: *mut libc::c_char = 0 as *mut libc::c_char;
                if strncmp(optarg,
                           b"00:04:20\x00" as *const u8 as
                               *const libc::c_char,
                           8 as libc::c_int as libc::c_ulong) == 0 {
                    logprint(b"%s %s:%d ignoring mac address from hardware player range 00:04:20:**:**:**\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 5],
                                                       &[libc::c_char; 5]>(b"main\x00")).as_ptr(),
                             453 as libc::c_int);
                } else {
                    let mut t: *mut libc::c_char =
                        strtok(optarg,
                               b":\x00" as *const u8 as *const libc::c_char);
                    while !t.is_null() && byte < 6 as libc::c_int {
                        let fresh0 = byte;
                        byte = byte + 1;
                        mac[fresh0 as usize] =
                            strtoul(t, &mut tmp, 16 as libc::c_int) as u8_t;
                        t =
                            strtok(0 as *mut libc::c_char,
                                   b":\x00" as *const u8 as
                                       *const libc::c_char)
                    }
                }
                current_block_129 = 10517665100358322178;
            }
            77 => {
                modelname = optarg;
                current_block_129 = 10517665100358322178;
            }
            114 => {
                let mut rstr: *mut libc::c_char =
                    next_param(optarg, ':' as i32 as libc::c_char);
                let mut dstr: *mut libc::c_char =
                    next_param(0 as *mut libc::c_char,
                               ':' as i32 as libc::c_char);
                if !rstr.is_null() &&
                       !strstr(rstr,
                               b",\x00" as *const u8 as
                                   *const libc::c_char).is_null() {
                    // parse sample rates and sort them
                    let mut r: *mut libc::c_char =
                        next_param(rstr, ',' as i32 as libc::c_char);
                    let mut tmp_0: [libc::c_uint; 18] =
                        [0 as libc::c_int as libc::c_uint, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
                    let mut i_0: libc::c_int = 0;
                    let mut j: libc::c_int = 0;
                    let mut last: libc::c_int = 999999 as libc::c_int;
                    i_0 = 0 as libc::c_int;
                    while !r.is_null() && i_0 < 18 as libc::c_int {
                        tmp_0[i_0 as usize] = atoi(r) as libc::c_uint;
                        r =
                            next_param(0 as *mut libc::c_char,
                                       ',' as i32 as libc::c_char);
                        i_0 += 1
                    }
                    i_0 = 0 as libc::c_int;
                    while i_0 < 18 as libc::c_int {
                        let mut largest: libc::c_int = 0 as libc::c_int;
                        j = 0 as libc::c_int;
                        while j < 18 as libc::c_int {
                            if tmp_0[j as usize] > largest as libc::c_uint &&
                                   tmp_0[j as usize] < last as libc::c_uint {
                                largest = tmp_0[j as usize] as libc::c_int
                            }
                            j += 1
                        }
                        last = largest;
                        rates[i_0 as usize] = last as libc::c_uint;
                        i_0 += 1
                    }
                } else if !rstr.is_null() {
                    // optstr is <min>-<max> or <max>, extract rates from test rates within this range
                    let mut ref_0: [libc::c_uint; 18] =
                        [768000 as libc::c_int as libc::c_uint,
                         705600 as libc::c_int as libc::c_uint,
                         384000 as libc::c_int as libc::c_uint,
                         352800 as libc::c_int as libc::c_uint,
                         192000 as libc::c_int as libc::c_uint,
                         176400 as libc::c_int as libc::c_uint,
                         96000 as libc::c_int as libc::c_uint,
                         88200 as libc::c_int as libc::c_uint,
                         48000 as libc::c_int as libc::c_uint,
                         44100 as libc::c_int as libc::c_uint,
                         32000 as libc::c_int as libc::c_uint,
                         24000 as libc::c_int as libc::c_uint,
                         22500 as libc::c_int as libc::c_uint,
                         16000 as libc::c_int as libc::c_uint,
                         12000 as libc::c_int as libc::c_uint,
                         11025 as libc::c_int as libc::c_uint,
                         8000 as libc::c_int as libc::c_uint,
                         0 as libc::c_int as libc::c_uint];
                    let mut str1: *mut libc::c_char =
                        next_param(rstr, '-' as i32 as libc::c_char);
                    let mut str2: *mut libc::c_char =
                        next_param(0 as *mut libc::c_char,
                                   '-' as i32 as libc::c_char);
                    let mut max: libc::c_uint =
                        if !str2.is_null() {
                            atoi(str2) as libc::c_uint
                        } else if !str1.is_null() {
                            atoi(str1) as libc::c_uint
                        } else { ref_0[0 as libc::c_int as usize] };
                    let mut min: libc::c_uint =
                        if !str1.is_null() && !str2.is_null() {
                            atoi(str1)
                        } else { 0 as libc::c_int } as libc::c_uint;
                    let mut tmp_1: libc::c_uint = 0;
                    let mut i_1: libc::c_int = 0;
                    let mut j_0: libc::c_int = 0;
                    if max < min { tmp_1 = max; max = min; min = tmp_1 }
                    rates[0 as libc::c_int as usize] = max;
                    i_1 = 0 as libc::c_int;
                    j_0 = 1 as libc::c_int;
                    while i_1 < 18 as libc::c_int {
                        if ref_0[i_1 as usize] <
                               rates[(j_0 - 1 as libc::c_int) as usize] &&
                               ref_0[i_1 as usize] >= min {
                            let fresh1 = j_0;
                            j_0 = j_0 + 1;
                            rates[fresh1 as usize] = ref_0[i_1 as usize]
                        }
                        i_1 += 1
                    }
                }
                if !dstr.is_null() { rate_delay = atoi(dstr) as libc::c_uint }
                if rates[0 as libc::c_int as usize] != 0 {
                    user_rates = 1 as libc::c_int != 0
                }
                current_block_129 = 10517665100358322178;
            }
            115 => {
                server = optarg;
                current_block_129 = 10517665100358322178;
            }
            110 => {
                name = optarg;
                current_block_129 = 10517665100358322178;
            }
            78 => {
                namefile = optarg;
                current_block_129 = 10517665100358322178;
            }
            87 => {
                pcm_check_header = 1 as libc::c_int != 0;
                current_block_129 = 10517665100358322178;
            }
            112 => {
                rt_priority = atoi(optarg) as libc::c_uint;
                if rt_priority > 99 as libc::c_int as libc::c_uint ||
                       rt_priority < 1 as libc::c_int as libc::c_uint {
                    fprintf(stderr,
                            b"\nError: invalid priority: %s\n\n\x00" as
                                *const u8 as *const libc::c_char, optarg);
                    usage(*argv.offset(0 as libc::c_int as isize));
                    exit(1 as libc::c_int);
                }
                current_block_129 = 10517665100358322178;
            }
            80 => {
                pidfile = optarg;
                current_block_129 = 10517665100358322178;
            }
            108 => { list_devices(); exit(0 as libc::c_int); }
            79 => {
                mixer_device = optarg;
                current_block_129 = 10517665100358322178;
            }
            76 => { list_mixers(mixer_device); exit(0 as libc::c_int); }
            88 => {
                linear_volume = 1 as libc::c_int != 0;
                current_block_129 = 10517665100358322178;
            }
            85 => {
                output_mixer_unmute = 1 as libc::c_int != 0;
                current_block_129 = 8353035839816271260;
            }
            86 => { current_block_129 = 8353035839816271260; }
            122 => {
                daemonize = 1 as libc::c_int != 0;
                current_block_129 = 10517665100358322178;
            }
            116 => { license(); exit(0 as libc::c_int); }
            63 => {
                usage(*argv.offset(0 as libc::c_int as isize));
                exit(0 as libc::c_int);
            }
            _ => {
                fprintf(stderr,
                        b"Arg error: %s\n\x00" as *const u8 as
                            *const libc::c_char,
                        *argv.offset(optind as isize));
                current_block_129 = 10517665100358322178;
            }
        }
        match current_block_129 {
            8353035839816271260 => {
                if !output_mixer.is_null() {
                    fprintf(stderr,
                            b"-U and -V option should not be used at same time\n\x00"
                                as *const u8 as *const libc::c_char);
                    exit(1 as libc::c_int);
                }
                output_mixer = optarg
            }
            _ => { }
        }
    }
    // warn if command line includes something which isn't parsed
    if optind < argc {
        fprintf(stderr,
                b"\nError: command line argument error\n\n\x00" as *const u8
                    as *const libc::c_char);
        usage(*argv.offset(0 as libc::c_int as isize));
        exit(1 as libc::c_int);
    }
    signal(2 as libc::c_int,
           Some(sighandler as unsafe extern "C" fn(_: libc::c_int) -> ()));
    signal(15 as libc::c_int,
           Some(sighandler as unsafe extern "C" fn(_: libc::c_int) -> ()));
    signal(3 as libc::c_int,
           Some(sighandler as unsafe extern "C" fn(_: libc::c_int) -> ()));
    signal(1 as libc::c_int,
           Some(sighandler as unsafe extern "C" fn(_: libc::c_int) -> ()));
    // set the output buffer size if not specified on the command line, take account of resampling
    if output_buf_size == 0 {
        output_buf_size =
            (44100 as libc::c_int * 8 as libc::c_int * 10 as libc::c_int) as
                libc::c_uint;
        if !resample.is_null() {
            let mut scale: libc::c_uint = 8 as libc::c_int as libc::c_uint;
            if rates[0 as libc::c_int as usize] != 0 {
                scale =
                    rates[0 as libc::c_int as
                              usize].wrapping_div(44100 as libc::c_int as
                                                      libc::c_uint);
                if scale > 8 as libc::c_int as libc::c_uint {
                    scale = 8 as libc::c_int as libc::c_uint
                }
                if scale < 1 as libc::c_int as libc::c_uint {
                    scale = 1 as libc::c_int as libc::c_uint
                }
            }
            output_buf_size = output_buf_size.wrapping_mul(scale)
        }
    }
    if !logfile.is_null() {
        if freopen(logfile, b"a\x00" as *const u8 as *const libc::c_char,
                   stderr).is_null() {
            fprintf(stderr,
                    b"error opening logfile %s: %s\n\x00" as *const u8 as
                        *const libc::c_char, logfile,
                    strerror(*__errno_location()));
        } else if log_output as libc::c_uint >=
                      lINFO as libc::c_int as libc::c_uint ||
                      log_stream as libc::c_uint >=
                          lINFO as libc::c_int as libc::c_uint ||
                      log_decode as libc::c_uint >=
                          lINFO as libc::c_int as libc::c_uint ||
                      log_slimproto as libc::c_uint >=
                          lINFO as libc::c_int as libc::c_uint {
            fprintf(stderr, b"\n%s\n\x00" as *const u8 as *const libc::c_char,
                    cmdline.as_mut_ptr());
        }
    }
    if !pidfile.is_null() {
        pidfp = fopen(pidfile, b"w\x00" as *const u8 as *const libc::c_char);
        if pidfp.is_null() {
            fprintf(stderr,
                    b"Error opening pidfile %s: %s\n\x00" as *const u8 as
                        *const libc::c_char, pidfile,
                    strerror(*__errno_location()));
            exit(1 as libc::c_int);
        }
        pidfile = realpath(pidfile, 0 as *mut libc::c_char)
        // daemonize will change cwd
    }
    if daemonize {
        if daemon(0 as libc::c_int,
                  if !logfile.is_null() {
                      1 as libc::c_int
                  } else { 0 as libc::c_int }) != 0 {
            fprintf(stderr,
                    b"error daemonizing: %s\n\x00" as *const u8 as
                        *const libc::c_char, strerror(*__errno_location()));
        }
    }
    if !pidfp.is_null() {
        fprintf(pidfp, b"%d\n\x00" as *const u8 as *const libc::c_char,
                getpid());
        fclose(pidfp);
    }
    stream_init(log_stream, stream_buf_size);
    if strcmp(output_device, b"-\x00" as *const u8 as *const libc::c_char) ==
           0 {
        output_init_stdout(log_output, output_buf_size, output_params,
                           rates.as_mut_ptr(), rate_delay);
    } else {
        output_init_alsa(log_output, output_device, output_buf_size,
                         output_params, rates.as_mut_ptr(), rate_delay,
                         rt_priority, idle, mixer_device, output_mixer,
                         output_mixer_unmute, linear_volume);
    }
    decode_init(log_decode, include_codecs, exclude_codecs);
    if !name.is_null() && !namefile.is_null() {
        fprintf(stderr,
                b"-n and -N option should not be used at same time\n\x00" as
                    *const u8 as *const libc::c_char);
        exit(1 as libc::c_int);
    }
    slimproto(log_slimproto, server, mac.as_mut_ptr(), name, namefile,
              modelname, maxSampleRate);
    decode_close();
    stream_close();
    if strcmp(output_device, b"-\x00" as *const u8 as *const libc::c_char) ==
           0 {
        output_close_stdout();
    } else { output_close_alsa(); }
    if !pidfile.is_null() {
        unlink(pidfile);
        free(pidfile as *mut libc::c_void);
    }
    exit(0 as libc::c_int);
}
#[cross_check(none)]
#[main]
pub fn main() {
    let mut args: Vec<*mut libc::c_char> = Vec::new();
    for arg in ::std::env::args() {
        args.push(::std::ffi::CString::new(arg).expect("Failed to convert argument into CString.").into_raw());
    };
    args.push(::std::ptr::null_mut());
    unsafe {
        ::std::process::exit(main_0((args.len() - 1) as libc::c_int,
                                    args.as_mut_ptr() as
                                        *mut *mut libc::c_char) as i32)
    }
}
