use ::libc;
extern "C" {
    pub type mpg123_handle_struct;
    #[no_mangle]
    fn malloc(_: libc::c_ulong) -> *mut libc::c_void;
    #[no_mangle]
    fn _checkfade(_: bool);
    #[no_mangle]
    fn dlopen(__file: *const libc::c_char, __mode: libc::c_int)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlsym(__handle: *mut libc::c_void, __name: *const libc::c_char)
     -> *mut libc::c_void;
    #[no_mangle]
    fn dlerror() -> *mut libc::c_char;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn _buf_used(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_space(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_read(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_write(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_inc_readp(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn _buf_inc_writep(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn decode_newstream(sample_rate: libc::c_uint,
                        supported_rates: *mut libc::c_uint) -> libc::c_uint;
    #[no_mangle]
    static mut loglevel: log_level;
    #[no_mangle]
    static mut streambuf: *mut buffer;
    #[no_mangle]
    static mut outputbuf: *mut buffer;
    #[no_mangle]
    static mut stream: streamstate;
    #[no_mangle]
    static mut output: outputstate;
    #[no_mangle]
    static mut decode: decodestate;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __int16_t = libc::c_short;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type int16_t = __int16_t;
pub type int32_t = __int32_t;
pub type u_int8_t = __uint8_t;
pub type u_int32_t = __uint32_t;
pub type u_int64_t = __uint64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type u8_t = u_int8_t;
pub type u32_t = u_int32_t;
pub type u64_t = u_int64_t;
pub type s16_t = int16_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type stream_state = libc::c_uint;
pub const RECV_HEADERS: stream_state = 7;
pub const SEND_HEADERS: stream_state = 6;
pub const STREAMING_HTTP: stream_state = 5;
pub const STREAMING_FILE: stream_state = 4;
pub const STREAMING_BUFFERING: stream_state = 3;
pub const STREAMING_WAIT: stream_state = 2;
pub const DISCONNECT: stream_state = 1;
pub const STOPPED: stream_state = 0;
pub type disconnect_code = libc::c_uint;
pub const TIMEOUT: disconnect_code = 4;
pub const UNREACHABLE: disconnect_code = 3;
pub const REMOTE_DISCONNECT: disconnect_code = 2;
pub const LOCAL_DISCONNECT: disconnect_code = 1;
pub const DISCONNECT_OK: disconnect_code = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct streamstate {
    pub state: stream_state,
    pub disconnect: disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: u32_t,
    pub meta_next: u32_t,
    pub meta_left: u32_t,
    pub meta_send: bool,
}
pub type decode_state = libc::c_uint;
pub const DECODE_ERROR: decode_state = 4;
pub const DECODE_COMPLETE: decode_state = 3;
pub const DECODE_RUNNING: decode_state = 2;
pub const DECODE_READY: decode_state = 1;
pub const DECODE_STOPPED: decode_state = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct decodestate {
    pub state: decode_state,
    pub new_stream: bool,
    pub mutex: pthread_mutex_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct codec {
    pub id: libc::c_char,
    pub types: *mut libc::c_char,
    pub min_read_bytes: libc::c_uint,
    pub min_space: libc::c_uint,
    pub open: Option<unsafe extern "C" fn(_: u8_t, _: u8_t, _: u8_t, _: u8_t)
                         -> ()>,
    pub close: Option<unsafe extern "C" fn() -> ()>,
    pub decode: Option<unsafe extern "C" fn() -> decode_state>,
}
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_RUNNING: output_state = 2;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
pub const MPG123_ERR: mpg123_errors = -1;
pub const MPG123_DONE: mpg123_errors = -12;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct mpg {
    pub h: *mut mpg123_handle,
    pub use16bit: bool,
    pub mpg123_init: Option<unsafe extern "C" fn() -> libc::c_int>,
    pub mpg123_feature: Option<unsafe extern "C" fn(_: mpg123_feature_set)
                                   -> libc::c_int>,
    pub mpg123_rates: Option<unsafe extern "C" fn(_: *mut *const libc::c_long,
                                                  _: *mut size_t) -> ()>,
    pub mpg123_format_none: Option<unsafe extern "C" fn(_: *mut mpg123_handle)
                                       -> libc::c_int>,
    pub mpg123_format: Option<unsafe extern "C" fn(_: *mut mpg123_handle,
                                                   _: libc::c_long,
                                                   _: libc::c_int,
                                                   _: libc::c_int)
                                  -> libc::c_int>,
    pub mpg123_new: Option<unsafe extern "C" fn(_: *const libc::c_char,
                                                _: *mut libc::c_int)
                               -> *mut mpg123_handle>,
    pub mpg123_delete: Option<unsafe extern "C" fn(_: *mut mpg123_handle)
                                  -> ()>,
    pub mpg123_open_feed: Option<unsafe extern "C" fn(_: *mut mpg123_handle)
                                     -> libc::c_int>,
    pub mpg123_decode: Option<unsafe extern "C" fn(_: *mut mpg123_handle,
                                                   _: *const libc::c_uchar,
                                                   _: size_t,
                                                   _: *mut libc::c_uchar,
                                                   _: size_t, _: *mut size_t)
                                  -> libc::c_int>,
    pub mpg123_getformat: Option<unsafe extern "C" fn(_: *mut mpg123_handle,
                                                      _: *mut libc::c_long,
                                                      _: *mut libc::c_int,
                                                      _: *mut libc::c_int)
                                     -> libc::c_int>,
    pub mpg123_plain_strerror: Option<unsafe extern "C" fn(_: libc::c_int)
                                          -> *const libc::c_char>,
}
pub type mpg123_handle = mpg123_handle_struct;
pub type mpg123_feature_set = libc::c_uint;
pub const MPG123_FEATURE_EQUALIZER: mpg123_feature_set = 14;
pub const MPG123_FEATURE_TIMEOUT_READ: mpg123_feature_set = 13;
pub const MPG123_FEATURE_PARSE_ICY: mpg123_feature_set = 12;
pub const MPG123_FEATURE_DECODE_NTOM: mpg123_feature_set = 11;
pub const MPG123_FEATURE_DECODE_DOWNSAMPLE: mpg123_feature_set = 10;
pub const MPG123_FEATURE_DECODE_ACCURATE: mpg123_feature_set = 9;
pub const MPG123_FEATURE_DECODE_LAYER3: mpg123_feature_set = 8;
pub const MPG123_FEATURE_DECODE_LAYER2: mpg123_feature_set = 7;
pub const MPG123_FEATURE_DECODE_LAYER1: mpg123_feature_set = 6;
pub const MPG123_FEATURE_PARSE_ID3V2: mpg123_feature_set = 5;
pub const MPG123_FEATURE_INDEX: mpg123_feature_set = 4;
pub const MPG123_FEATURE_OUTPUT_32BIT: mpg123_feature_set = 3;
pub const MPG123_FEATURE_OUTPUT_16BIT: mpg123_feature_set = 2;
pub const MPG123_FEATURE_OUTPUT_8BIT: mpg123_feature_set = 1;
pub const MPG123_FEATURE_ABI_UTF8OPEN: mpg123_feature_set = 0;
pub const MPG123_NEW_FORMAT: mpg123_errors = -11;
pub const MPG123_ENC_SIGNED_32: mpg123_enc_enum = 4480;
pub const MPG123_ENC_SIGNED_16: mpg123_enc_enum = 208;
pub type mpg123_enc_enum = libc::c_uint;
pub const MPG123_ENC_ANY: mpg123_enc_enum = 30719;
pub const MPG123_ENC_FLOAT_64: mpg123_enc_enum = 1024;
pub const MPG123_ENC_FLOAT_32: mpg123_enc_enum = 512;
pub const MPG123_ENC_UNSIGNED_24: mpg123_enc_enum = 24576;
pub const MPG123_ENC_SIGNED_24: mpg123_enc_enum = 20608;
pub const MPG123_ENC_UNSIGNED_32: mpg123_enc_enum = 8448;
pub const MPG123_ENC_ALAW_8: mpg123_enc_enum = 8;
pub const MPG123_ENC_ULAW_8: mpg123_enc_enum = 4;
pub const MPG123_ENC_SIGNED_8: mpg123_enc_enum = 130;
pub const MPG123_ENC_UNSIGNED_8: mpg123_enc_enum = 1;
pub const MPG123_ENC_UNSIGNED_16: mpg123_enc_enum = 96;
pub const MPG123_ENC_FLOAT: mpg123_enc_enum = 3584;
pub const MPG123_ENC_SIGNED: mpg123_enc_enum = 128;
pub const MPG123_ENC_32: mpg123_enc_enum = 256;
pub const MPG123_ENC_24: mpg123_enc_enum = 16384;
pub const MPG123_ENC_16: mpg123_enc_enum = 64;
pub const MPG123_ENC_8: mpg123_enc_enum = 15;
pub type mpg123_errors = libc::c_int;
pub const MPG123_INT_OVERFLOW: mpg123_errors = 43;
pub const MPG123_LFS_OVERFLOW: mpg123_errors = 42;
pub const MPG123_BAD_CUSTOM_IO: mpg123_errors = 41;
pub const MPG123_LSEEK_FAILED: mpg123_errors = 40;
pub const MPG123_BAD_VALUE: mpg123_errors = 39;
pub const MPG123_MISSING_FEATURE: mpg123_errors = 38;
pub const MPG123_BAD_DECODER_SETUP: mpg123_errors = 37;
pub const MPG123_INDEX_FAIL: mpg123_errors = 36;
pub const MPG123_NO_INDEX: mpg123_errors = 35;
pub const MPG123_BAD_KEY: mpg123_errors = 34;
pub const MPG123_NULL_POINTER: mpg123_errors = 33;
pub const MPG123_NO_RELSEEK: mpg123_errors = 32;
pub const MPG123_NULL_BUFFER: mpg123_errors = 31;
pub const MPG123_BAD_ALIGN: mpg123_errors = 30;
pub const MPG123_NO_8BIT: mpg123_errors = 29;
pub const MPG123_RESYNC_FAIL: mpg123_errors = 28;
pub const MPG123_OUT_OF_SYNC: mpg123_errors = 27;
pub const MPG123_BAD_INDEX_PAR: mpg123_errors = 26;
pub const MPG123_BAD_PARS: mpg123_errors = 25;
pub const MPG123_NO_READER: mpg123_errors = 24;
pub const MPG123_NO_SEEK: mpg123_errors = 23;
pub const MPG123_BAD_FILE: mpg123_errors = 22;
pub const MPG123_NO_TIMEOUT: mpg123_errors = 21;
pub const MPG123_BAD_WHENCE: mpg123_errors = 20;
pub const MPG123_NO_SEEK_FROM_END: mpg123_errors = 19;
pub const MPG123_ERR_READER: mpg123_errors = 18;
pub const MPG123_ERR_NULL: mpg123_errors = 17;
pub const MPG123_BAD_BAND: mpg123_errors = 16;
pub const MPG123_BAD_TYPES: mpg123_errors = 15;
pub const MPG123_NO_SPACE: mpg123_errors = 14;
pub const MPG123_NO_GAPLESS: mpg123_errors = 13;
pub const MPG123_BAD_RVA: mpg123_errors = 12;
pub const MPG123_NO_BUFFERS: mpg123_errors = 11;
pub const MPG123_BAD_HANDLE: mpg123_errors = 10;
pub const MPG123_BAD_DECODER: mpg123_errors = 9;
pub const MPG123_NOT_INITIALIZED: mpg123_errors = 8;
pub const MPG123_OUT_OF_MEM: mpg123_errors = 7;
pub const MPG123_BAD_BUFFER: mpg123_errors = 6;
pub const MPG123_BAD_PARAM: mpg123_errors = 5;
pub const MPG123_ERR_16TO8TABLE: mpg123_errors = 4;
pub const MPG123_BAD_RATE: mpg123_errors = 3;
pub const MPG123_BAD_CHANNEL: mpg123_errors = 2;
pub const MPG123_BAD_OUTFORMAT: mpg123_errors = 1;
pub const MPG123_OK: mpg123_errors = 0;
pub const MPG123_NEED_MORE: mpg123_errors = -10;
static mut m: *mut mpg = 0 as *const mpg as *mut mpg;
unsafe extern "C" fn mpg_decode() -> decode_state {
    let mut bytes: size_t = 0;
    let mut space: size_t = 0;
    let mut size: size_t = 0;
    let mut ret: libc::c_int = 0;
    let mut write_buf: *mut u8_t = 0 as *mut u8_t;
    pthread_mutex_lock(&mut (*streambuf).mutex);
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    bytes =
        if _buf_used(streambuf) < _buf_cont_read(streambuf) {
            _buf_used(streambuf)
        } else { _buf_cont_read(streambuf) } as size_t;
    space =
        if _buf_space(outputbuf) < _buf_cont_write(outputbuf) {
            _buf_space(outputbuf)
        } else { _buf_cont_write(outputbuf) } as size_t;
    write_buf = (*outputbuf).writep;
    bytes =
        if bytes < 512 as libc::c_int as libc::c_ulong {
            bytes
        } else { 512 as libc::c_int as libc::c_ulong };
    space =
        if space < (32 as libc::c_int * 1024 as libc::c_int) as libc::c_ulong
           {
            space
        } else { (32 as libc::c_int * 1024 as libc::c_int) as libc::c_ulong };
    if (*m).use16bit {
        space =
            space.wrapping_div(8 as libc::c_int as
                                   libc::c_ulong).wrapping_mul(4 as
                                                                   libc::c_int
                                                                   as
                                                                   libc::c_ulong)
    }
    // only get the new stream information on first call so we can reset decode.direct appropriately
    if decode.new_stream { space = 0 as libc::c_int as size_t }
    ret =
        (*m).mpg123_decode.expect("non-null function pointer")((*m).h,
                                                               (*streambuf).readp,
                                                               bytes,
                                                               write_buf,
                                                               space,
                                                               &mut size);
    if ret == MPG123_NEW_FORMAT as libc::c_int {
        if decode.new_stream {
            let mut rate: libc::c_long = 0;
            let mut channels: libc::c_int = 0;
            let mut enc: libc::c_int = 0;
            (*m).mpg123_getformat.expect("non-null function pointer")((*m).h,
                                                                      &mut rate,
                                                                      &mut channels,
                                                                      &mut enc);
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d setting track_start\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 11],
                                                   &[libc::c_char; 11]>(b"mpg_decode\x00")).as_ptr(),
                         125 as libc::c_int);
            }
            output.next_sample_rate =
                decode_newstream(rate as libc::c_uint,
                                 output.supported_rates.as_mut_ptr());
            output.track_start = (*outputbuf).writep;
            if output.fade_mode as u64 != 0 {
                _checkfade(1 as libc::c_int != 0);
            }
            decode.new_stream = 0 as libc::c_int != 0
        } else if loglevel as libc::c_uint >=
                      lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d format change mid stream - not supported\n\x00"
                         as *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"mpg_decode\x00")).as_ptr(),
                     135 as libc::c_int);
        }
    }
    // expand 16bit output to 32bit samples
    if (*m).use16bit {
        let mut iptr: *mut s16_t = 0 as *mut s16_t;
        let mut optr: *mut s32_t = 0 as *mut s32_t;
        let mut count: size_t =
            size.wrapping_div(2 as libc::c_int as libc::c_ulong);
        size = count.wrapping_mul(4 as libc::c_int as libc::c_ulong);
        iptr = (write_buf as *mut s16_t).offset(count as isize);
        optr = (write_buf as *mut s32_t).offset(count as isize);
        loop  {
            let fresh0 = count;
            count = count.wrapping_sub(1);
            if !(fresh0 != 0) { break ; }
            iptr = iptr.offset(-1);
            optr = optr.offset(-1);
            *optr = (*iptr as libc::c_int) << 16 as libc::c_int
        }
    }
    _buf_inc_readp(streambuf, bytes as libc::c_uint);
    _buf_inc_writep(outputbuf, size as libc::c_uint);
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
    if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d write %u frames\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 11],
                                           &[libc::c_char; 11]>(b"mpg_decode\x00")).as_ptr(),
                 163 as libc::c_int,
                 size.wrapping_div(8 as libc::c_int as libc::c_ulong));
    }
    if ret == MPG123_DONE as libc::c_int ||
           bytes == 0 as libc::c_int as libc::c_ulong &&
               size == 0 as libc::c_int as libc::c_ulong &&
               stream.state as libc::c_uint <=
                   DISCONNECT as libc::c_int as libc::c_uint {
        pthread_mutex_unlock(&mut (*streambuf).mutex);
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d stream complete\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"mpg_decode\x00")).as_ptr(),
                     167 as libc::c_int);
        }
        return DECODE_COMPLETE
    }
    pthread_mutex_unlock(&mut (*streambuf).mutex);
    if ret == MPG123_ERR as libc::c_int {
        if loglevel as libc::c_uint >= lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d Error\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"mpg_decode\x00")).as_ptr(),
                     174 as libc::c_int);
        }
        return DECODE_COMPLETE
    }
    // OK and NEED_MORE keep running
    return DECODE_RUNNING;
}
unsafe extern "C" fn mpg_open(mut size: u8_t, mut rate: u8_t, mut chan: u8_t,
                              mut endianness: u8_t) {
    let mut err: libc::c_int = 0;
    let mut list: *const libc::c_long = 0 as *const libc::c_long;
    let mut count: size_t = 0;
    let mut i: size_t = 0;
    if !(*m).h.is_null() {
        (*m).mpg123_delete.expect("non-null function pointer")((*m).h);
    }
    (*m).h =
        (*m).mpg123_new.expect("non-null function pointer")(0 as
                                                                *const libc::c_char,
                                                            &mut err);
    if (*m).h.is_null() {
        if loglevel as libc::c_uint >= lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d new error: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"mpg_open\x00")).as_ptr(),
                     194 as libc::c_int,
                     (*m).mpg123_plain_strerror.expect("non-null function pointer")(err));
        }
    }
    // restrict output to 32bit or 16bit signed 2 channel based on library capability
    (*m).mpg123_rates.expect("non-null function pointer")(&mut list,
                                                          &mut count);
    (*m).mpg123_format_none.expect("non-null function pointer")((*m).h);
    i = 0 as libc::c_int as size_t;
    while i < count {
        (*m).mpg123_format.expect("non-null function pointer")((*m).h,
                                                               *list.offset(i
                                                                                as
                                                                                isize),
                                                               2 as
                                                                   libc::c_int,
                                                               if (*m).use16bit
                                                                      as
                                                                      libc::c_int
                                                                      != 0 {
                                                                   MPG123_ENC_SIGNED_16
                                                                       as
                                                                       libc::c_int
                                                               } else {
                                                                   MPG123_ENC_SIGNED_32
                                                                       as
                                                                       libc::c_int
                                                               });
        i = i.wrapping_add(1)
    }
    err = (*m).mpg123_open_feed.expect("non-null function pointer")((*m).h);
    if err != 0 {
        if loglevel as libc::c_uint >= lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d open feed error: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"mpg_open\x00")).as_ptr(),
                     207 as libc::c_int,
                     (*m).mpg123_plain_strerror.expect("non-null function pointer")(err));
        }
    };
}
unsafe extern "C" fn mpg_close() {
    (*m).mpg123_delete.expect("non-null function pointer")((*m).h);
    (*m).h = 0 as *mut mpg123_handle;
}
unsafe extern "C" fn load_mpg() -> bool {
    let mut handle: *mut libc::c_void =
        dlopen(b"libmpg123.so.0\x00" as *const u8 as *const libc::c_char,
               0x2 as libc::c_int);
    let mut err: *mut libc::c_char = 0 as *mut libc::c_char;
    if handle.is_null() {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d dlerror: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"load_mpg\x00")).as_ptr(),
                     222 as libc::c_int, dlerror());
        }
        return 0 as libc::c_int != 0
    }
    (*m).mpg123_init =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn()
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"mpg123_init\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*m).mpg123_feature =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                mpg123_feature_set)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"mpg123_feature\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*m).mpg123_rates =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut *const libc::c_long,
                                                            _: *mut size_t)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mpg123_rates\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mpg123_format_none =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mpg123_handle)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"mpg123_format_none\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*m).mpg123_format =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mpg123_handle,
                                                            _: libc::c_long,
                                                            _: libc::c_int,
                                                            _: libc::c_int)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"mpg123_format\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*m).mpg123_new =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *const libc::c_char,
                                                            _:
                                                                *mut libc::c_int)
                                           ->
                                               *mut mpg123_handle>>(dlsym(handle,
                                                                          b"mpg123_new\x00"
                                                                              as
                                                                              *const u8
                                                                              as
                                                                              *const libc::c_char));
    (*m).mpg123_delete =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mpg123_handle)
                                           ->
                                               ()>>(dlsym(handle,
                                                          b"mpg123_delete\x00"
                                                              as *const u8 as
                                                              *const libc::c_char));
    (*m).mpg123_open_feed =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mpg123_handle)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"mpg123_open_feed\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*m).mpg123_decode =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mpg123_handle,
                                                            _:
                                                                *const libc::c_uchar,
                                                            _: size_t,
                                                            _:
                                                                *mut libc::c_uchar,
                                                            _: size_t,
                                                            _: *mut size_t)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"mpg123_decode\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*m).mpg123_getformat =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_:
                                                                *mut mpg123_handle,
                                                            _:
                                                                *mut libc::c_long,
                                                            _:
                                                                *mut libc::c_int,
                                                            _:
                                                                *mut libc::c_int)
                                           ->
                                               libc::c_int>>(dlsym(handle,
                                                                   b"mpg123_getformat\x00"
                                                                       as
                                                                       *const u8
                                                                       as
                                                                       *const libc::c_char));
    (*m).mpg123_plain_strerror =
        ::std::mem::transmute::<*mut libc::c_void,
                                Option<unsafe extern "C" fn(_: libc::c_int)
                                           ->
                                               *const libc::c_char>>(dlsym(handle,
                                                                           b"mpg123_plain_strerror\x00"
                                                                               as
                                                                               *const u8
                                                                               as
                                                                               *const libc::c_char));
    err = dlerror();
    if !err.is_null() {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d dlerror: %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"load_mpg\x00")).as_ptr(),
                     239 as libc::c_int, err);
        }
        return 0 as libc::c_int != 0
    }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d loaded libmpg123.so.0\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"load_mpg\x00")).as_ptr(),
                 243 as libc::c_int);
    }
    return 1 as libc::c_int != 0;
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
// output_pack.c
// output_vis.c
// dop.c
// codecs
#[no_mangle]
pub unsafe extern "C" fn register_mpg() -> *mut codec {
    static mut ret: codec =
        unsafe {
            {
                let mut init =
                    codec{id: 'm' as i32 as libc::c_char,
                          types:
                              b"mp3\x00" as *const u8 as *const libc::c_char
                                  as *mut libc::c_char,
                          min_read_bytes: 512 as libc::c_int as libc::c_uint,
                          min_space:
                              (32 as libc::c_int * 1024 as libc::c_int) as
                                  libc::c_uint,
                          open:
                              Some(mpg_open as
                                       unsafe extern "C" fn(_: u8_t, _: u8_t,
                                                            _: u8_t, _: u8_t)
                                           -> ()),
                          close:
                              Some(mpg_close as unsafe extern "C" fn() -> ()),
                          decode:
                              Some(mpg_decode as
                                       unsafe extern "C" fn()
                                           -> decode_state),};
                init
            }
        };
    m = malloc(::std::mem::size_of::<mpg>() as libc::c_ulong) as *mut mpg;
    if m.is_null() { return 0 as *mut codec }
    (*m).h = 0 as *mut mpg123_handle;
    if !load_mpg() { return 0 as *mut codec }
    (*m).mpg123_init.expect("non-null function pointer")();
    (*m).use16bit =
        (*m).mpg123_feature.expect("non-null function pointer")(MPG123_FEATURE_OUTPUT_32BIT)
            != 0;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d using mpg to decode mp3\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"register_mpg\x00")).as_ptr(),
                 275 as libc::c_int);
    }
    return &mut ret;
}
