use ::libc;
extern "C" {
    #[no_mangle]
    fn memcpy(_: *mut libc::c_void, _: *const libc::c_void, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memcmp(_: *const libc::c_void, _: *const libc::c_void,
              _: libc::c_ulong) -> libc::c_int;
    #[no_mangle]
    fn _checkfade(_: bool);
    #[no_mangle]
    fn decode_newstream(sample_rate_0: libc::c_uint,
                        supported_rates: *mut libc::c_uint) -> libc::c_uint;
    #[no_mangle]
    fn buf_adjust(buf: *mut buffer, mod_0: size_t);
    #[no_mangle]
    fn _buf_inc_writep(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn _buf_inc_readp(buf: *mut buffer, by: libc::c_uint);
    #[no_mangle]
    fn _buf_cont_write(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_cont_read(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_space(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn _buf_used(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    /* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
    #[no_mangle]
    static mut loglevel: log_level;
    #[no_mangle]
    static mut streambuf: *mut buffer;
    #[no_mangle]
    static mut outputbuf: *mut buffer;
    #[no_mangle]
    static mut stream: streamstate;
    #[no_mangle]
    static mut output: outputstate;
    #[no_mangle]
    static mut decode: decodestate;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type int32_t = __int32_t;
pub type u_int8_t = __uint8_t;
pub type u_int32_t = __uint32_t;
pub type u_int64_t = __uint64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type u8_t = u_int8_t;
pub type u32_t = u_int32_t;
pub type u64_t = u_int64_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type stream_state = libc::c_uint;
pub const RECV_HEADERS: stream_state = 7;
pub const SEND_HEADERS: stream_state = 6;
pub const STREAMING_HTTP: stream_state = 5;
pub const STREAMING_FILE: stream_state = 4;
pub const STREAMING_BUFFERING: stream_state = 3;
pub const STREAMING_WAIT: stream_state = 2;
pub const DISCONNECT: stream_state = 1;
pub const STOPPED: stream_state = 0;
pub type disconnect_code = libc::c_uint;
pub const TIMEOUT: disconnect_code = 4;
pub const UNREACHABLE: disconnect_code = 3;
pub const REMOTE_DISCONNECT: disconnect_code = 2;
pub const LOCAL_DISCONNECT: disconnect_code = 1;
pub const DISCONNECT_OK: disconnect_code = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct streamstate {
    pub state: stream_state,
    pub disconnect: disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: u32_t,
    pub meta_next: u32_t,
    pub meta_left: u32_t,
    pub meta_send: bool,
}
pub type decode_state = libc::c_uint;
pub const DECODE_ERROR: decode_state = 4;
pub const DECODE_COMPLETE: decode_state = 3;
pub const DECODE_RUNNING: decode_state = 2;
pub const DECODE_READY: decode_state = 1;
pub const DECODE_STOPPED: decode_state = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct decodestate {
    pub state: decode_state,
    pub new_stream: bool,
    pub mutex: pthread_mutex_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct codec {
    pub id: libc::c_char,
    pub types: *mut libc::c_char,
    pub min_read_bytes: libc::c_uint,
    pub min_space: libc::c_uint,
    pub open: Option<unsafe extern "C" fn(_: u8_t, _: u8_t, _: u8_t, _: u8_t)
                         -> ()>,
    pub close: Option<unsafe extern "C" fn() -> ()>,
    pub decode: Option<unsafe extern "C" fn() -> decode_state>,
}
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_RUNNING: output_state = 2;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
pub const AIFF: header_format = 2;
pub type header_format = libc::c_uint;
pub const WAVE: header_format = 1;
pub const UNKNOWN: header_format = 0;
#[no_mangle]
pub static mut pcm_check_header: bool = 0 as libc::c_int != 0;
static mut sample_rates: [u32_t; 17] =
    [11025 as libc::c_int as u32_t, 22050 as libc::c_int as u32_t,
     32000 as libc::c_int as u32_t, 44100 as libc::c_int as u32_t,
     48000 as libc::c_int as u32_t, 8000 as libc::c_int as u32_t,
     12000 as libc::c_int as u32_t, 16000 as libc::c_int as u32_t,
     24000 as libc::c_int as u32_t, 96000 as libc::c_int as u32_t,
     88200 as libc::c_int as u32_t, 176400 as libc::c_int as u32_t,
     192000 as libc::c_int as u32_t, 352800 as libc::c_int as u32_t,
     384000 as libc::c_int as u32_t, 705600 as libc::c_int as u32_t,
     768000 as libc::c_int as u32_t];
static mut sample_rate: u32_t = 0;
static mut sample_size: u32_t = 0;
static mut channels: u32_t = 0;
static mut bigendian: bool = false;
static mut limit: bool = false;
static mut audio_left: u32_t = 0;
static mut bytes_per_frame: u32_t = 0;
unsafe extern "C" fn _check_header() {
    let mut ptr: *mut u8_t = (*streambuf).readp;
    let mut bytes: libc::c_uint =
        if _buf_used(streambuf) < _buf_cont_read(streambuf) {
            _buf_used(streambuf)
        } else { _buf_cont_read(streambuf) };
    let mut format: header_format = UNKNOWN;
    // simple parsing of wav and aiff headers and get to samples
    if bytes > 12 as libc::c_int as libc::c_uint {
        if memcmp(ptr as *const libc::c_void,
                  b"RIFF\x00" as *const u8 as *const libc::c_char as
                      *const libc::c_void, 4 as libc::c_int as libc::c_ulong)
               == 0 &&
               memcmp(ptr.offset(8 as libc::c_int as isize) as
                          *const libc::c_void,
                      b"WAVE\x00" as *const u8 as *const libc::c_char as
                          *const libc::c_void,
                      4 as libc::c_int as libc::c_ulong) == 0 {
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d WAVE\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                         80 as libc::c_int);
            }
            format = WAVE
        } else if memcmp(ptr as *const libc::c_void,
                         b"FORM\x00" as *const u8 as *const libc::c_char as
                             *const libc::c_void,
                         4 as libc::c_int as libc::c_ulong) == 0 &&
                      (memcmp(ptr.offset(8 as libc::c_int as isize) as
                                  *const libc::c_void,
                              b"AIFF\x00" as *const u8 as *const libc::c_char
                                  as *const libc::c_void,
                              4 as libc::c_int as libc::c_ulong) == 0 ||
                           memcmp(ptr.offset(8 as libc::c_int as isize) as
                                      *const libc::c_void,
                                  b"AIFC\x00" as *const u8 as
                                      *const libc::c_char as
                                      *const libc::c_void,
                                  4 as libc::c_int as libc::c_ulong) == 0) {
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d AIFF\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                         83 as libc::c_int);
            }
            format = AIFF
        }
    }
    if format as libc::c_uint != UNKNOWN as libc::c_int as libc::c_uint {
        ptr = ptr.offset(12 as libc::c_int as isize);
        bytes = bytes.wrapping_sub(12 as libc::c_int as libc::c_uint);
        while bytes >= 8 as libc::c_int as libc::c_uint {
            let mut id: [libc::c_char; 5] = [0; 5];
            let mut len: libc::c_uint = 0;
            memcpy(id.as_mut_ptr() as *mut libc::c_void,
                   ptr as *const libc::c_void,
                   4 as libc::c_int as libc::c_ulong);
            id[4 as libc::c_int as usize] = '\u{0}' as i32 as libc::c_char;
            if format as libc::c_uint == WAVE as libc::c_int as libc::c_uint {
                len =
                    (*ptr.offset(4 as libc::c_int as isize) as libc::c_int |
                         (*ptr.offset(5 as libc::c_int as isize) as
                              libc::c_int) << 8 as libc::c_int |
                         (*ptr.offset(6 as libc::c_int as isize) as
                              libc::c_int) << 16 as libc::c_int |
                         (*ptr.offset(7 as libc::c_int as isize) as
                              libc::c_int) << 24 as libc::c_int) as
                        libc::c_uint
            } else {
                len =
                    ((*ptr.offset(4 as libc::c_int as isize) as libc::c_int)
                         << 24 as libc::c_int |
                         (*ptr.offset(5 as libc::c_int as isize) as
                              libc::c_int) << 16 as libc::c_int |
                         (*ptr.offset(6 as libc::c_int as isize) as
                              libc::c_int) << 8 as libc::c_int |
                         *ptr.offset(7 as libc::c_int as isize) as
                             libc::c_int) as libc::c_uint
            }
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d header: %s len: %d\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 14],
                                                   &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                         104 as libc::c_int, id.as_mut_ptr(), len);
            }
            if format as libc::c_uint == WAVE as libc::c_int as libc::c_uint
                   &&
                   memcmp(ptr as *const libc::c_void,
                          b"data\x00" as *const u8 as *const libc::c_char as
                              *const libc::c_void,
                          4 as libc::c_int as libc::c_ulong) == 0 {
                ptr = ptr.offset(8 as libc::c_int as isize);
                _buf_inc_readp(streambuf,
                               ptr.wrapping_offset_from((*streambuf).readp) as
                                   libc::c_long as libc::c_uint);
                audio_left = len;
                if audio_left == 0xffffffff as libc::c_uint ||
                       audio_left == 0x7fffeffc as libc::c_int as libc::c_uint
                   {
                    if loglevel as libc::c_uint >=
                           lINFO as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d wav audio size unknown: %u\n\x00"
                                     as *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 14],
                                                           &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                                 112 as libc::c_int, audio_left);
                    }
                    limit = 0 as libc::c_int != 0
                } else {
                    if loglevel as libc::c_uint >=
                           lINFO as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d wav audio size: %u\n\x00" as
                                     *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 14],
                                                           &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                                 115 as libc::c_int, audio_left);
                    }
                    limit = 1 as libc::c_int != 0
                }
                return
            }
            if format as libc::c_uint == AIFF as libc::c_int as libc::c_uint
                   &&
                   memcmp(ptr as *const libc::c_void,
                          b"SSND\x00" as *const u8 as *const libc::c_char as
                              *const libc::c_void,
                          4 as libc::c_int as libc::c_ulong) == 0 &&
                   bytes >= 16 as libc::c_int as libc::c_uint {
                let mut offset: libc::c_uint =
                    ((*ptr.offset(8 as libc::c_int as isize) as libc::c_int)
                         << 24 as libc::c_int |
                         (*ptr.offset(9 as libc::c_int as isize) as
                              libc::c_int) << 16 as libc::c_int |
                         (*ptr.offset(10 as libc::c_int as isize) as
                              libc::c_int) << 8 as libc::c_int |
                         *ptr.offset(11 as libc::c_int as isize) as
                             libc::c_int) as libc::c_uint;
                // following 4 bytes is blocksize - ignored
                ptr =
                    ptr.offset((8 as libc::c_int + 8 as libc::c_int) as
                                   isize);
                _buf_inc_readp(streambuf,
                               ptr.offset(offset as
                                              isize).wrapping_offset_from((*streambuf).readp)
                                   as libc::c_long as libc::c_uint);
                // Reading from an upsampled stream, length could be wrong.
				// Only use length in header for files.
                if stream.state as libc::c_uint ==
                       STREAMING_FILE as libc::c_int as libc::c_uint {
                    audio_left =
                        len.wrapping_sub(8 as libc::c_int as
                                             libc::c_uint).wrapping_sub(offset);
                    if loglevel as libc::c_uint >=
                           lINFO as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d aif audio size: %u\n\x00" as
                                     *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 14],
                                                           &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                                 131 as libc::c_int, audio_left);
                    }
                    limit = 1 as libc::c_int != 0
                }
                return
            }
            if format as libc::c_uint == WAVE as libc::c_int as libc::c_uint
                   &&
                   memcmp(ptr as *const libc::c_void,
                          b"fmt \x00" as *const u8 as *const libc::c_char as
                              *const libc::c_void,
                          4 as libc::c_int as libc::c_ulong) == 0 &&
                   bytes >= 24 as libc::c_int as libc::c_uint {
                // override the server parsed values with our own
                channels =
                    (*ptr.offset(10 as libc::c_int as isize) as libc::c_int |
                         (*ptr.offset(11 as libc::c_int as isize) as
                              libc::c_int) << 8 as libc::c_int) as u32_t;
                sample_rate =
                    (*ptr.offset(12 as libc::c_int as isize) as libc::c_int |
                         (*ptr.offset(13 as libc::c_int as isize) as
                              libc::c_int) << 8 as libc::c_int |
                         (*ptr.offset(14 as libc::c_int as isize) as
                              libc::c_int) << 16 as libc::c_int |
                         (*ptr.offset(15 as libc::c_int as isize) as
                              libc::c_int) << 24 as libc::c_int) as u32_t;
                sample_size =
                    ((*ptr.offset(22 as libc::c_int as isize) as libc::c_int |
                          (*ptr.offset(23 as libc::c_int as isize) as
                               libc::c_int) << 8 as libc::c_int) /
                         8 as libc::c_int) as u32_t;
                bigendian = 0 as libc::c_int != 0;
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d pcm size: %u rate: %u chan: %u bigendian: %u\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                             143 as libc::c_int, sample_size, sample_rate,
                             channels, bigendian as libc::c_int);
                }
            }
            if format as libc::c_uint == AIFF as libc::c_int as libc::c_uint
                   &&
                   memcmp(ptr as *const libc::c_void,
                          b"COMM\x00" as *const u8 as *const libc::c_char as
                              *const libc::c_void,
                          4 as libc::c_int as libc::c_ulong) == 0 &&
                   bytes >= 26 as libc::c_int as libc::c_uint {
                let mut exponent: libc::c_int = 0;
                // override the server parsed values with our own
                channels =
                    ((*ptr.offset(8 as libc::c_int as isize) as libc::c_int)
                         << 8 as libc::c_int |
                         *ptr.offset(9 as libc::c_int as isize) as
                             libc::c_int) as u32_t;
                sample_size =
                    (((*ptr.offset(14 as libc::c_int as isize) as libc::c_int)
                          << 8 as libc::c_int |
                          *ptr.offset(15 as libc::c_int as isize) as
                              libc::c_int) / 8 as libc::c_int) as u32_t;
                bigendian = 1 as libc::c_int != 0;
                // sample rate is encoded as IEEE 80 bit extended format
				// make some assumptions to simplify processing - only use first 32 bits of mantissa
                exponent =
                    ((*ptr.offset(16 as libc::c_int as isize) as libc::c_int &
                          0x7f as libc::c_int) << 8 as libc::c_int |
                         *ptr.offset(17 as libc::c_int as isize) as
                             libc::c_int) - 16383 as libc::c_int -
                        31 as libc::c_int;
                sample_rate =
                    ((*ptr.offset(18 as libc::c_int as isize) as libc::c_int)
                         << 24 as libc::c_int |
                         (*ptr.offset(19 as libc::c_int as isize) as
                              libc::c_int) << 16 as libc::c_int |
                         (*ptr.offset(20 as libc::c_int as isize) as
                              libc::c_int) << 8 as libc::c_int |
                         *ptr.offset(21 as libc::c_int as isize) as
                             libc::c_int) as u32_t;
                while exponent < 0 as libc::c_int {
                    sample_rate >>= 1 as libc::c_int;
                    exponent += 1
                }
                while exponent > 0 as libc::c_int {
                    sample_rate <<= 1 as libc::c_int;
                    exponent -= 1
                }
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d pcm size: %u rate: %u chan: %u bigendian: %u\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                             158 as libc::c_int, sample_size, sample_rate,
                             channels, bigendian as libc::c_int);
                }
            }
            if bytes >= len.wrapping_add(8 as libc::c_int as libc::c_uint) {
                ptr =
                    ptr.offset(len.wrapping_add(8 as libc::c_int as
                                                    libc::c_uint) as isize);
                bytes =
                    bytes.wrapping_sub(len.wrapping_add(8 as libc::c_int as
                                                            libc::c_uint))
            } else {
                if loglevel as libc::c_uint >=
                       lWARN as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d run out of data\n\x00" as *const u8 as
                                 *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                             165 as libc::c_int);
                }
                return
            }
        }
    } else if loglevel as libc::c_uint >= lWARN as libc::c_int as libc::c_uint
     {
        logprint(b"%s %s:%d unknown format - can\'t parse header\n\x00" as
                     *const u8 as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 14],
                                           &[libc::c_char; 14]>(b"_check_header\x00")).as_ptr(),
                 171 as libc::c_int);
    };
}
unsafe extern "C" fn pcm_decode() -> decode_state {
    let mut bytes: libc::c_uint = 0;
    let mut in_0: libc::c_uint = 0;
    let mut out: libc::c_uint = 0;
    let mut frames: frames_t = 0;
    let mut count: frames_t = 0;
    let mut optr: *mut u32_t = 0 as *mut u32_t;
    let mut iptr: *mut u8_t = 0 as *mut u8_t;
    let mut tmp: [u8_t; 16] = [0; 16];
    pthread_mutex_lock(&mut (*streambuf).mutex);
    if decode.new_stream as libc::c_int != 0 &&
           (stream.state as libc::c_uint ==
                STREAMING_FILE as libc::c_int as libc::c_uint ||
                pcm_check_header as libc::c_int != 0) {
        _check_header();
    }
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    bytes =
        if _buf_used(streambuf) < _buf_cont_read(streambuf) {
            _buf_used(streambuf)
        } else { _buf_cont_read(streambuf) };
    out =
        (if _buf_space(outputbuf) < _buf_cont_write(outputbuf) {
             _buf_space(outputbuf)
         } else {
             _buf_cont_write(outputbuf)
         }).wrapping_div(8 as libc::c_int as libc::c_uint);
    if stream.state as libc::c_uint <=
           DISCONNECT as libc::c_int as libc::c_uint &&
           bytes == 0 as libc::c_int as libc::c_uint ||
           limit as libc::c_int != 0 &&
               audio_left == 0 as libc::c_int as libc::c_uint {
        pthread_mutex_unlock(&mut (*outputbuf).mutex);
        pthread_mutex_unlock(&mut (*streambuf).mutex);
        return DECODE_COMPLETE
    }
    if decode.new_stream {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d setting track_start\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"pcm_decode\x00")).as_ptr(),
                     206 as libc::c_int);
        }
        output.track_start = (*outputbuf).writep;
        decode.new_stream = 0 as libc::c_int != 0;
        output.next_sample_rate =
            decode_newstream(sample_rate,
                             output.supported_rates.as_mut_ptr());
        if output.fade_mode as u64 != 0 { _checkfade(1 as libc::c_int != 0); }
        bytes_per_frame = channels.wrapping_mul(sample_size)
    }
    optr = (*outputbuf).writep as *mut u32_t;
    iptr = (*streambuf).readp;
    in_0 = bytes.wrapping_div(bytes_per_frame);
    //  handle frame wrapping round end of streambuf
	//  - only need if resizing of streambuf does not avoid this, could occur in localfile case
    if in_0 == 0 as libc::c_int as libc::c_uint &&
           bytes > 0 as libc::c_int as libc::c_uint &&
           _buf_used(streambuf) >= bytes_per_frame {
        memcpy(tmp.as_mut_ptr() as *mut libc::c_void,
               iptr as *const libc::c_void, bytes as libc::c_ulong);
        memcpy(tmp.as_mut_ptr().offset(bytes as isize) as *mut libc::c_void,
               (*streambuf).buf as *const libc::c_void,
               bytes_per_frame.wrapping_sub(bytes) as libc::c_ulong);
        iptr = tmp.as_mut_ptr();
        in_0 = 1 as libc::c_int as libc::c_uint
    }
    frames = if in_0 < out { in_0 } else { out };
    frames =
        if frames < 4096 as libc::c_int as libc::c_uint {
            frames
        } else { 4096 as libc::c_int as libc::c_uint };
    if limit as libc::c_int != 0 &&
           frames.wrapping_mul(bytes_per_frame) > audio_left {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d reached end of audio\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 11],
                                               &[libc::c_char; 11]>(b"pcm_decode\x00")).as_ptr(),
                     261 as libc::c_int);
        }
        frames = audio_left.wrapping_div(bytes_per_frame)
    }
    count = frames.wrapping_mul(channels);
    if channels == 2 as libc::c_int as libc::c_uint {
        if sample_size == 1 as libc::c_int as libc::c_uint {
            loop  {
                let fresh0 = count;
                count = count.wrapping_sub(1);
                if !(fresh0 != 0) { break ; }
                let fresh1 = iptr;
                iptr = iptr.offset(1);
                let fresh2 = optr;
                optr = optr.offset(1);
                *fresh2 =
                    ((*fresh1 as libc::c_int) << 24 as libc::c_int) as u32_t
            }
        } else if sample_size == 2 as libc::c_int as libc::c_uint {
            if bigendian {
                loop  {
                    let fresh3 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh3 != 0) { break ; }
                    let fresh4 = optr;
                    optr = optr.offset(1);
                    *fresh4 =
                        ((*iptr as libc::c_int) << 24 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int) as u32_t;
                    iptr = iptr.offset(2 as libc::c_int as isize)
                }
            } else {
                loop  {
                    let fresh5 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh5 != 0) { break ; }
                    let fresh6 = optr;
                    optr = optr.offset(1);
                    *fresh6 =
                        ((*iptr as libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 24 as libc::c_int) as u32_t;
                    iptr = iptr.offset(2 as libc::c_int as isize)
                }
            }
        } else if sample_size == 3 as libc::c_int as libc::c_uint {
            if bigendian {
                loop  {
                    let fresh7 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh7 != 0) { break ; }
                    let fresh8 = optr;
                    optr = optr.offset(1);
                    *fresh8 =
                        ((*iptr as libc::c_int) << 24 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(2 as libc::c_int as isize) as
                                  libc::c_int) << 8 as libc::c_int) as u32_t;
                    iptr = iptr.offset(3 as libc::c_int as isize)
                }
            } else {
                loop  {
                    let fresh9 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh9 != 0) { break ; }
                    let fresh10 = optr;
                    optr = optr.offset(1);
                    *fresh10 =
                        ((*iptr as libc::c_int) << 8 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(2 as libc::c_int as isize) as
                                  libc::c_int) << 24 as libc::c_int) as u32_t;
                    iptr = iptr.offset(3 as libc::c_int as isize)
                }
            }
        } else if sample_size == 4 as libc::c_int as libc::c_uint {
            if bigendian {
                loop  {
                    let fresh11 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh11 != 0) { break ; }
                    let fresh12 = optr;
                    optr = optr.offset(1);
                    *fresh12 =
                        ((*iptr as libc::c_int) << 24 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(2 as libc::c_int as isize) as
                                  libc::c_int) << 8 as libc::c_int |
                             *iptr.offset(3 as libc::c_int as isize) as
                                 libc::c_int) as u32_t;
                    iptr = iptr.offset(4 as libc::c_int as isize)
                }
            } else {
                loop  {
                    let fresh13 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh13 != 0) { break ; }
                    let fresh14 = optr;
                    optr = optr.offset(1);
                    *fresh14 =
                        (*iptr as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 8 as libc::c_int |
                             (*iptr.offset(2 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(3 as libc::c_int as isize) as
                                  libc::c_int) << 24 as libc::c_int) as u32_t;
                    iptr = iptr.offset(4 as libc::c_int as isize)
                }
            }
        }
    } else if channels == 1 as libc::c_int as libc::c_uint {
        if sample_size == 1 as libc::c_int as libc::c_uint {
            loop  {
                let fresh15 = count;
                count = count.wrapping_sub(1);
                if !(fresh15 != 0) { break ; }
                let fresh16 = iptr;
                iptr = iptr.offset(1);
                *optr =
                    ((*fresh16 as libc::c_int) << 24 as libc::c_int) as u32_t;
                *optr.offset(1 as libc::c_int as isize) = *optr;
                optr = optr.offset(2 as libc::c_int as isize)
            }
        } else if sample_size == 2 as libc::c_int as libc::c_uint {
            if bigendian {
                loop  {
                    let fresh17 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh17 != 0) { break ; }
                    *optr =
                        ((*iptr as libc::c_int) << 24 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int) as u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(2 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            } else {
                loop  {
                    let fresh18 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh18 != 0) { break ; }
                    *optr =
                        ((*iptr as libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 24 as libc::c_int) as u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(2 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            }
        } else if sample_size == 3 as libc::c_int as libc::c_uint {
            if bigendian {
                loop  {
                    let fresh19 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh19 != 0) { break ; }
                    *optr =
                        ((*iptr as libc::c_int) << 24 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(2 as libc::c_int as isize) as
                                  libc::c_int) << 8 as libc::c_int) as u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(3 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            } else {
                loop  {
                    let fresh20 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh20 != 0) { break ; }
                    *optr =
                        ((*iptr as libc::c_int) << 8 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(2 as libc::c_int as isize) as
                                  libc::c_int) << 24 as libc::c_int) as u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(3 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            }
        } else if sample_size == 4 as libc::c_int as libc::c_uint {
            if bigendian {
                loop  {
                    let fresh21 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh21 != 0) { break ; }
                    let fresh22 = optr;
                    optr = optr.offset(1);
                    *fresh22 =
                        ((*iptr as libc::c_int) << 24 as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(2 as libc::c_int as isize) as
                                  libc::c_int) << 8 as libc::c_int |
                             *iptr.offset(3 as libc::c_int as isize) as
                                 libc::c_int) as u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(4 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            } else {
                loop  {
                    let fresh23 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh23 != 0) { break ; }
                    let fresh24 = optr;
                    optr = optr.offset(1);
                    *fresh24 =
                        (*iptr as libc::c_int |
                             (*iptr.offset(1 as libc::c_int as isize) as
                                  libc::c_int) << 8 as libc::c_int |
                             (*iptr.offset(2 as libc::c_int as isize) as
                                  libc::c_int) << 16 as libc::c_int |
                             (*iptr.offset(3 as libc::c_int as isize) as
                                  libc::c_int) << 24 as libc::c_int) as u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(4 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            }
        }
    } else {
        logprint(b"%s %s:%d unsupported channels\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 11],
                                           &[libc::c_char; 11]>(b"pcm_decode\x00")).as_ptr(),
                 366 as libc::c_int);
    }
    if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d decoded %u frames\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 11],
                                           &[libc::c_char; 11]>(b"pcm_decode\x00")).as_ptr(),
                 369 as libc::c_int, frames);
    }
    _buf_inc_readp(streambuf, frames.wrapping_mul(bytes_per_frame));
    if limit {
        audio_left =
            (audio_left as
                 libc::c_uint).wrapping_sub(frames.wrapping_mul(bytes_per_frame))
                as u32_t as u32_t
    }
    _buf_inc_writep(outputbuf,
                    frames.wrapping_mul(8 as libc::c_int as libc::c_uint));
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
    pthread_mutex_unlock(&mut (*streambuf).mutex);
    return DECODE_RUNNING;
}
unsafe extern "C" fn pcm_open(mut size: u8_t, mut rate: u8_t, mut chan: u8_t,
                              mut endianness: u8_t) {
    sample_size =
        (size as libc::c_int - '0' as i32 + 1 as libc::c_int) as u32_t;
    sample_rate = sample_rates[(rate as libc::c_int - '0' as i32) as usize];
    channels = (chan as libc::c_int - '0' as i32) as u32_t;
    bigendian = endianness as libc::c_int == '0' as i32;
    limit = 0 as libc::c_int != 0;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d pcm size: %u rate: %u chan: %u bigendian: %u\n\x00"
                     as *const u8 as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"pcm_open\x00")).as_ptr(),
                 397 as libc::c_int, sample_size, sample_rate, channels,
                 bigendian as libc::c_int);
    }
    buf_adjust(streambuf, sample_size.wrapping_mul(channels) as size_t);
}
unsafe extern "C" fn pcm_close() {
    buf_adjust(streambuf, 1 as libc::c_int as size_t);
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
// output_pack.c
// output_vis.c
// dop.c
// codecs
#[no_mangle]
pub unsafe extern "C" fn register_pcm() -> *mut codec {
    if pcm_check_header {
        static mut ret: codec =
            unsafe {
                {
                    let mut init =
                        codec{id: 'p' as i32 as libc::c_char,
                              types:
                                  b"wav,aif,pcm\x00" as *const u8 as
                                      *const libc::c_char as
                                      *mut libc::c_char,
                              min_read_bytes:
                                  4096 as libc::c_int as libc::c_uint,
                              min_space:
                                  102400 as libc::c_int as libc::c_uint,
                              open:
                                  Some(pcm_open as
                                           unsafe extern "C" fn(_: u8_t,
                                                                _: u8_t,
                                                                _: u8_t,
                                                                _: u8_t)
                                               -> ()),
                              close:
                                  Some(pcm_close as
                                           unsafe extern "C" fn() -> ()),
                              decode:
                                  Some(pcm_decode as
                                           unsafe extern "C" fn()
                                               -> decode_state),};
                    init
                }
            };
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d using pcm to decode wav,aif,pcm\n\x00" as
                         *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 13],
                                               &[libc::c_char; 13]>(b"register_pcm\x00")).as_ptr(),
                     418 as libc::c_int);
        }
        return &mut ret
    } else {
        static mut ret_0: codec =
            unsafe {
                {
                    let mut init =
                        codec{id: 'p' as i32 as libc::c_char,
                              types:
                                  b"aif,pcm\x00" as *const u8 as
                                      *const libc::c_char as
                                      *mut libc::c_char,
                              min_read_bytes:
                                  4096 as libc::c_int as libc::c_uint,
                              min_space:
                                  102400 as libc::c_int as libc::c_uint,
                              open:
                                  Some(pcm_open as
                                           unsafe extern "C" fn(_: u8_t,
                                                                _: u8_t,
                                                                _: u8_t,
                                                                _: u8_t)
                                               -> ()),
                              close:
                                  Some(pcm_close as
                                           unsafe extern "C" fn() -> ()),
                              decode:
                                  Some(pcm_decode as
                                           unsafe extern "C" fn()
                                               -> decode_state),};
                    init
                }
            };
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d using pcm to decode aif,pcm\n\x00" as
                         *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 13],
                                               &[libc::c_char; 13]>(b"register_pcm\x00")).as_ptr(),
                     433 as libc::c_int);
        }
        return &mut ret_0
    };
}
